{*****************************************************************************
 *
 *  FMAccount.pas - Account form  (28-July-1998)
 *
 *  Copyright (c) 1998-99 Michael Haller
 *
 *  Author:     Michael Haller
 *  E-mail:     michael@discountdrive.com
 *  Homepage:   http://www.discountdrive.com/sunrise
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation;
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *----------------------------------------------------------------------------
 *
 *  Revision history:
 *
 *     DATE     REV                 DESCRIPTION
 *  ----------- --- ----------------------------------------------------------
 *
 *****************************************************************************}

unit FMAccount;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, PXStuff, LangSup, ComboBoxEx, ImgList;

type
  TAccountForm = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Bevel1: TBevel;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Bevel2: TBevel;
    Label8: TLabel;
    Bevel3: TBevel;
    Label9: TLabel;
    Edit6: TEdit;
    Label10: TLabel;
    Edit7: TEdit;
    Label11: TLabel;
    Edit8: TEdit;
    Label12: TLabel;
    Edit9: TEdit;
    Label13: TLabel;
    Bevel4: TBevel;
    Label14: TLabel;
    Edit10: TEdit;
    Label15: TLabel;
    Edit11: TEdit;
    Label16: TLabel;
    Bevel5: TBevel;
    Button1: TButton;
    Button2: TButton;
    TabSheet4: TTabSheet;
    Label17: TLabel;
    Bevel6: TBevel;
    Label18: TLabel;
    Edit12: TEdit;
    Label19: TLabel;
    Edit13: TEdit;
    Label20: TLabel;
    Label23: TLabel;
    Panel2: TPanel;
    Image1: TImage;
    Image2: TImage;
    Label24: TLabel;
    Button3: TButton;
    Label21: TLabel;
    Edit14: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label22: TLabel;
    ComboBoxEx1: TComboBoxEx;
    ImageList1: TImageList;
    CheckBox3: TCheckBox;
    TabSheet5: TTabSheet;
    Label25: TLabel;
    Bevel7: TBevel;
    Label26: TLabel;
    Memo1: TMemo;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    CreateNewAccount: Boolean;
    procedure LoadAccountData(Data: PAccountData);
    procedure SaveAccountData(var Data: PAccountData);
  end;

var
  AccountForm: TAccountForm;

implementation

{$R *.DFM}

uses
  Main;

procedure TAccountForm.LoadAccountData(Data: PAccountData);
begin
  Edit1.Text := Data^.Name;
  Edit2.Text := Data^.FromMail;
  Edit3.Text := Data^.FromDesc;
  Edit4.Text := Data^.ReplyMail;
  Edit5.Text := Data^.ReplyDesc;
  Edit6.Text := Data^.POPServer;
  Edit7.Text := Data^.POPPort;
  Edit8.Text := Data^.POPUser;
  Edit9.Text := Data^.POPPass;
  Edit10.Text := Data^.SMTPServer;
  Edit11.Text := Data^.SMTPPort;
  Edit12.Text := Data^.KeepFilter;
  Edit13.Text := Data^.DeleteFilter;
  Edit14.Text := Data^.Organization;
  Checkbox1.Checked := (Data^.DoPOP = 1);
  Checkbox2.Checked := (Data^.DoSMTP = 1);
  Checkbox3.Checked := (Data^.PromptPassword = 1);
  ComboBoxEx1.Value := IntToStr(Data^.StandardDownload);
  Memo1.Lines.Clear;
  if FileExists(Data^.Path+'signat.txt') then
    Memo1.Lines.LoadFromfile(Data^.Path+'signat.txt');
  CheckBox1Click(Self);
end;

procedure TAccountForm.SaveAccountData(var Data: PAccountData);
begin
  Data^.Name := Edit1.Text;
  if CreateNewAccount then begin
    Data^.Path := sAccountRootFolder+MainForm.GetUniqueAccountFolder(Data^.Name)+'\';
    CreateFolder(Data^.Path);
  end;
  Data^.FromMail := Edit2.Text;
  Data^.FromDesc := Edit3.Text;
  Data^.ReplyMail := Edit4.Text;
  Data^.ReplyDesc := Edit5.Text;
  Data^.POPServer := Edit6.Text;
  Data^.POPPort := Edit7.Text;
  Data^.POPUser := Edit8.Text;
  Data^.POPPass := Edit9.Text;
  Data^.SMTPServer := Edit10.Text;
  Data^.SMTPPort := Edit11.Text;
  Data^.KeepFilter := Edit12.Text;
  Data^.DeleteFilter := Edit13.Text;
  Data^.Organization := Edit14.Text;
  Data^.DoPOP := BolToInt(Checkbox1.Checked);
  Data^.DoSMTP := BolToInt(Checkbox2.Checked);
  Data^.StandardDownload := StrToInt(ComboBoxEx1.Value);
  Data^.PromptPassword := BolToInt(Checkbox3.Checked);
  Memo1.Lines.SaveToFile(Data^.Path+'signat.txt');
end;

procedure TAccountForm.FormShow(Sender: TObject);
begin
  Edit9.PasswordChar := '*'; //for Hackers :-)
end;

procedure TAccountForm.Button1Click(Sender: TObject);
begin
  if Edit2.Text = '' then MessageDlg(MainForm.ListBox1.Items[37], mtwarning, [mbOK], 0)
  else
  ModalResult := mrOK;
end;

procedure TAccountForm.FormCreate(Sender: TObject);
begin
  AttachLanguageToForm(Self);
  if bOfficeFonts then Font.Name := sOfficeFontName;
  Image1.Picture.Bitmap := MainForm.Image5.Picture.Bitmap;
  Memo1.Font := MainForm.DefaultFont;
  Label16.Caption := Label16.Caption+' ';
  Label2.Caption := Label2.Caption+' ';
  Label7.Caption := Label7.Caption+' ';
  Label8.Caption := Label8.Caption+' ';
  Label13.Caption := Label13.Caption+' ';
  Label17.Caption := Label17.Caption+' ';
  Label25.Caption := Label25.Caption+' ';
  ComboBoxex1.Items[0] := Label30.Caption;
  ComboBoxex1.Items[1] := Label29.Caption;
  ComboBoxex1.Items[2] := Label28.Caption;
  ComboBoxex1.Items[3] := Label27.Caption;
  ImageList1.ResourceLoad(rtBitmap, 'PX501', clFuchsia);
end;

procedure TAccountForm.CheckBox1Click(Sender: TObject);
var
  B: Boolean;
begin
  B := not CheckBox3.Checked;
  if CheckBox1.Checked = False then B := False;
  Edit9.Enabled := B;
  B := CheckBox1.Checked;
  Label9.Enabled := B;
  Label10.Enabled := B;
  Label11.Enabled := B;
  Label12.Enabled := B;
  Edit6.Enabled := B;
  Edit7.Enabled := B;
  Edit8.Enabled := B;
  CheckBox3.Enabled := B;
  B := CheckBox2.Checked;
  Label14.Enabled := B;
  Label15.Enabled := B;
  Edit10.Enabled := B;
  Edit11.Enabled := B;
end;

procedure TAccountForm.Button3Click(Sender: TObject);
begin
  Application.HelpContext(19);
end;

end.
