{*****************************************************************************
 *
 *  Main.pas - Phoenix Main Form  (19-July-1998)
 *
 *  Copyright (c) 1998-99 Michael Haller
 *
 *  Author:     Michael Haller
 *  E-mail:     michael@discountdrive.com
 *  Homepage:   http://www.discountdrive.com/sunrise/
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation;
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *----------------------------------------------------------------------------
 *
 *  Revision history:
 *
 *     DATE     REV                 DESCRIPTION
 *  ----------- --- ----------------------------------------------------------
 *
 *****************************************************************************}

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ToolWin, Menus, Buttons, MailParser, FMInfo, FMTips, FMEnviro,
  FMMailOptions, FMAccount, PXStuff, INIFiles, FMFolder, Registry, FileCtrl,
  FMOnline, ShellAPI, ClipBrd, ParserSup, ExtCtrls, ComCtrls, FMSelectMail,
  FMAddress, XPrinter, TreeViewEx, FMDirectory, FMSignature, ImgList,
  EnhListView, ExtListView, FMSearch, LangSup, FMEditAdr, DialUp, StatusBarEx,
  FMSelBook, FMStdMail, FMSpellCheck, TDOnline, PanelEx;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    AboutPhoenix1: TMenuItem;
    Splitter1: TSplitter;
    Panel1: TPanel;
    RichEdit1: TRichEdit;
    Splitter2: TSplitter;
    TreeView1: TTreeViewEx;
    ImageList1: TImageList;
    ImageList2: TImageList;
    Account1: TMenuItem;
    New1: TMenuItem;
    Properties1: TMenuItem;
    Folder1: TMenuItem;
    New2: TMenuItem;
    Delete1: TMenuItem;
    N1: TMenuItem;
    Properties2: TMenuItem;
    Delete2: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    FetchMails1: TMenuItem;
    Enhanced1: TMenuItem;
    EmptyTrashBin1: TMenuItem;
    PopupMenu1: TPopupMenu;
    NewFolder1: TMenuItem;
    DeleteFolder1: TMenuItem;
    N4: TMenuItem;
    NewAccount1: TMenuItem;
    DeleteAccount1: TMenuItem;
    N5: TMenuItem;
    EmptyTrashBin2: TMenuItem;
    N6: TMenuItem;
    Properties3: TMenuItem;
    Exit1: TMenuItem;
    Splitter3: TSplitter;
    PopupMenu2: TPopupMenu;
    Open1: TMenuItem;
    N7: TMenuItem;
    Saveas1: TMenuItem;
    Delete3: TMenuItem;
    Add1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Message1: TMenuItem;
    Properties4: TMenuItem;
    New3: TMenuItem;
    Delete4: TMenuItem;
    N8: TMenuItem;
    ToggleUnreadFlag1: TMenuItem;
    Replay1: TMenuItem;
    ReplayQuoted1: TMenuItem;
    N10: TMenuItem;
    Attachment1: TMenuItem;
    Open2: TMenuItem;
    Save1: TMenuItem;
    N9: TMenuItem;
    AddFile1: TMenuItem;
    DeleteFile1: TMenuItem;
    PopupMenu3: TPopupMenu;
    NewMessage1: TMenuItem;
    DeleteMessage1: TMenuItem;
    N11: TMenuItem;
    Replay2: TMenuItem;
    ReplayQuoted2: TMenuItem;
    N12: TMenuItem;
    ToggleReadUnreadFlag1: TMenuItem;
    Properties5: TMenuItem;
    PopupMenu4: TPopupMenu;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete5: TMenuItem;
    N13: TMenuItem;
    SelectAll1: TMenuItem;
    Edit1: TMenuItem;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    Delete6: TMenuItem;
    SelectAll2: TMenuItem;
    File1: TMenuItem;
    SendMail1: TMenuItem;
    N16: TMenuItem;
    GoOnline1: TMenuItem;
    N18: TMenuItem;
    FetchMail1: TMenuItem;
    SendMail2: TMenuItem;
    EnvironmentOptions1: TMenuItem;
    N19: TMenuItem;
    TipoftheDay1: TMenuItem;
    Panel2: TPanelEx;
    Bevel1: TBevel;
    Panel3: TPanel;
    SpeedButton2: TSpeedButtonEx;
    SpeedButton3: TSpeedButtonEx;
    SpeedButton4: TSpeedButtonEx;
    SpeedButton5: TSpeedButtonEx;
    SpeedButton6: TSpeedButtonEx;
    PopupMenu5: TPopupMenu;
    Reply1: TMenuItem;
    ReplyQuoted1: TMenuItem;
    N21: TMenuItem;
    AddressBook1: TMenuItem;
    SpeedButton9: TSpeedButtonEx;
    N22: TMenuItem;
    Print1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrinterSetup1: TMenuItem;
    PrintDialog1: TPrintDialog;
    XPrint1: TXPrint;
    Contents1: TMenuItem;
    PhoenixMailHomePage1: TMenuItem;
    N23: TMenuItem;
    Signature1: TMenuItem;
    Forward1: TMenuItem;
    Redirect1: TMenuItem;
    Forward2: TMenuItem;
    Redirect2: TMenuItem;
    ListView1: TExtListView;
    Timer1: TTimer;
    Panel4: TPanel;
    Image2: TImage;
    CheckBox1: TCheckBox;
    PopupMenu6: TPopupMenu;
    ShowPhoenixMail1: TMenuItem;
    Modal1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    Image3: TImage;
    N24: TMenuItem;
    FetchSendMails1: TMenuItem;
    N25: TMenuItem;
    NewMessage2: TMenuItem;
    AddressBook2: TMenuItem;
    SearchMessage1: TMenuItem;
    N26: TMenuItem;
    SaveAs2: TMenuItem;
    SaveAs3: TMenuItem;
    SaveDialog1: TSaveDialog;
    SelectAllMessages1: TMenuItem;
    SelectAllMessages2: TMenuItem;
    N28: TMenuItem;
    N29: TMenuItem;
    Label1: TLabel;
    ListBox1: TListBox;
    Image5: TImage;
    N15: TMenuItem;
    N17: TMenuItem;
    AddtoAdressbook1: TMenuItem;
    AddtoAdressbook2: TMenuItem;
    Timer2: TTimer;
    Label2: TLabel;
    SpeedButton10: TSpeedButtonEx;
    SpellCheck1: TMenuItem;
    QuickView1: TMenuItem;
    QuickView2: TMenuItem;
    Image6: TImage;
    Image7: TImage;
    ImageList3: TImageList;
    Panel7: TPanel;
    Bevel2: TBevel;
    DialUp1: TDialUp;
    Memo1: TMemo;
    Image10: TImage;
    EmptyRepository1: TMenuItem;
    EmptyRepository2: TMenuItem;
    CheckBox2: TCheckBox;
    Panel6: TPanel;
    Label3: TLabel;
    Panel9: TPanel;
    ListView2: TListView;
    Panel11: TPanel;
    ASpeedButton1: TSpeedButton;
    StatusBar1: TStatusBarEx;
    Image9: TImage;
    Label4: TLabel;
    PaintBox1: TPaintBox;
    SpeedButton8: TSpeedButtonEx;
    SpeedButton1: TSpeedButtonEx;
    SpeedButton7: TSpeedButtonEx;
    SpeedButton13: TSpeedButtonEx;
    SpeedButton14: TSpeedButtonEx;
    SpeedButton15: TSpeedButtonEx;
    SpeedButton16: TSpeedButtonEx;
    SpeedButton17: TSpeedButtonEx;
    SpeedButton12: TSpeedButtonEx;
    SpeedButton11: TSpeedButtonEx;
    CancelOnlineOperation1: TMenuItem;
    Image4: TImage;
    Label5: TLabel;
    N14: TMenuItem;
    Bugs1: TMenuItem;
    Suggestins1: TMenuItem;
    PopupMenu7: TPopupMenu;
    FlatButtons1: TMenuItem;
    SmallButtons1: TMenuItem;
    N20: TMenuItem;
    Configure1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure TreeView1Deletion(Sender: TObject; Node: TTreeNode);
    procedure Properties1Click(Sender: TObject);
    procedure Properties2Click(Sender: TObject);
    procedure New2Click(Sender: TObject);
    procedure TreeView1Edited(Sender: TObject; Node: TTreeNode; var S: String);
    procedure Delete1Click(Sender: TObject);
    procedure Delete2Click(Sender: TObject);
    procedure Enhanced1Click(Sender: TObject);
    procedure EmptyTrashBin1Click(Sender: TObject);
    procedure Folder1Click(Sender: TObject);
    procedure Account1Click(Sender: TObject);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Properties3Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FetchMails1Click(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure Open1Click(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure Add1Click(Sender: TObject);
    procedure Delete3Click(Sender: TObject);
    procedure ToggleUnreadFlag1Click(Sender: TObject);
    procedure Properties4Click(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
    procedure TreeView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Delete4Click(Sender: TObject);
    procedure New3Click(Sender: TObject);
    procedure Replay1Click(Sender: TObject);
    procedure ReplayQuoted1Click(Sender: TObject);
    procedure PopupMenu4Popup(Sender: TObject);
    procedure Delete5Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SendMails1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListView2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GoOnline1Click(Sender: TObject);
    procedure EnvironmentOptions1Click(Sender: TObject);
    procedure AboutPhoenix1Click(Sender: TObject);
    procedure TipoftheDay1Click(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrinterSetup1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Signature1Click(Sender: TObject);
    procedure Forward1Click(Sender: TObject);
    procedure Redirect1Click(Sender: TObject);
    procedure ListView1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PopupMenu2Popup(Sender: TObject);
    procedure ListView1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure ListView1DrawHeader(Control: TWinControl;
      var ACanvas: TCanvas; Index: Integer; var ARect: TRect;
      Selected: Boolean; var DefaultDrawing: Boolean);
    procedure MenuItem3DrawIteehm(Sender: TObject; ACanvas: TCanvas;
      ARect: TRect; Selected: Boolean);
    procedure MenuItem3MeasureItem(Sender: TObject; ACanvas: TCanvas;
      var Width, Height: Integer);
    procedure ShowPhoenixMail1Click(Sender: TObject);
    procedure Modal1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SearchMessage1Click(Sender: TObject);
    procedure SaveAs3Click(Sender: TObject);
    procedure Message1Click(Sender: TObject);
    procedure SelectAllMessages1Click(Sender: TObject);
    procedure TreeView1Compare(Sender: TObject; Node1, Node2: TTreeNode;
      Data: Integer; var Compare: Integer);
    procedure AddtoAdressbook1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure SpellCheck1Click(Sender: TObject);
    procedure QuickView1Click(Sender: TObject);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure Contents1Click(Sender: TObject);
    procedure DialUp1StatusEvent(Sender: TObject; MessageText: String;
      Error: Boolean);
    procedure EmptyRepository1Click(Sender: TObject);
    procedure ASpeedButton1Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure CancelOnlineOperation1Click(Sender: TObject);
    procedure Panel2Paint(Sender: TObject);
    procedure Configure1Click(Sender: TObject);
    procedure FlatButtons1Click(Sender: TObject);
    procedure SmallButtons1Click(Sender: TObject);
    procedure PopupMenu7Popup(Sender: TObject);
    procedure TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    MinutesSinceStart, AnimationPosition: Integer;
    AreWeOnline, AnimationToLeft, bCurSmlTlbButtons: Boolean;
    BKAttachments1, BKAttachments2: TStringList;
    NotifyIconData : TNotifyIconData;
    TrayIcon: HIcon;
    DragDropDefWndProc, DragDropWndProcInstance: Pointer;
    ReadCounter, DefaultTlbButtonHeight, DefaultTlbButtonWidth: Integer;
    procedure DragDropWndProc(var Message: TMessage);
    procedure DragDropFiles(hDropHandle: HDrop);
    procedure WMTaskIcon(var Message: TMessage); message WM_TASKICON;
    procedure WMSysCommand(var Message: TMessage); message WM_SYSCOMMAND;
    procedure WndProc(var Message: TMessage); override;
    //procedure WMDrawItem(var Msg: TWMDrawItem); message WM_DRAWITEM;
    //procedure WMMeasureItem(var Msg: TWMMeasureItem); message WM_MEASUREITEM;
    //procedure DrawPopUpMenuItem(Item: TMenuItem; DC: HDC; ARect: TRect; Selected: Boolean);
    procedure ScanForAccounts(TreeView: TTreeView);
    procedure SaveAccountDataToFile(Data: PAccountData);
    procedure SaveFolderDataToFile(Data: PFolderData);
    procedure ActualizeTrash;
    procedure UpdateListView;
    procedure SetAccountMenusEnabled(OnlyFalse: Boolean);
    procedure SetMessageMenusEnabled;
    procedure ActualizeStatusBar;
    procedure BackupAttachments;
    procedure RestoreAttachments;
    procedure OnlineSession(OnlineTyp: Byte);
    procedure AddAttachment(Filename: String);
    procedure CreateGradientBitmap(StartPos: Integer; var GBitmap: TBitmap);
  public
    { Public declarations }
    ToolbarSeperators: TList;
    ActualMailFile: String;
    DefaultFont: TFont;
    AccountsNode, TrashNode, RepositoryNode: TTreeNode;
    Terminating, OnlineThreadTerminated, ReadyToClose: Boolean;
    OnlineThreadCounter: Integer;
    GradientBmp, AniBmp1, AniBmp2: TBitmap;
    function NewMessage(ShowDlg, Signat: Boolean; ASubject, ATo, AFrom: String; NewText: TStringList): Boolean;
    procedure AppMinimize(Sender: TObject);
    function GetActualAccount: TTreeNode;
    procedure DoSaveMessage;
    function GetUniqueAccountFolder(Name: String): String;
    function GetToolbarButttonByIndex(Index: Integer; var ImageIndex: Integer): TSpeedButtonEx;
    procedure SetToolbarButtonOrder;
  end;

const
  iToolbarButtonCount = 17;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

var
  TextFile: Text;

procedure TMainForm.FormCreate(Sender: TObject);
var
  SHFileInfo: TSHFileInfo;
  I, E: Integer;
  Bitmap: TBitmap;
  IniFile: TIniFile;
  C: TColor;

  procedure SetBitmapToButton(var S: TSpeedButtonEx; I: Integer);
  begin
    Bitmap := TBitmap.Create;
    ImageList3.GetBitmap(I, Bitmap);
    S.Glyph.Assign(Bitmap);
    Bitmap.Free;
  end;

begin
  AttachLanguageToForm(Self);
  Caption := Application.Title;
  Icon := Application.Icon;
  MinutesSinceStart := 0;
  AreWeOnline := False;
  Terminating := False;
  bCurSmlTlbButtons := False;
  //from InitializePX
  IniFile := TIniFile.Create(sSettingsFile);
  sAccountsCaption := IniFile.ReadString('Captions', 'Accounts', MainForm.ListBox1.Items[0]);
  sTrashBagCaption := IniFile.ReadString('Captions', 'TrashBag', MainForm.ListBox1.Items[1]);
  sRepositoryCaption := IniFile.ReadString('Captions', 'Repository', MainForm.ListBox1.Items[2]);
  //Get accounts
  ScanForAccounts(TreeView1);
  ActualizeTrash;
  TreeView1.FullExpand;
  TreeView1.AlphaSort;
  ImageList2.Handle := SHGetFileInfo('', 0, SHFileInfo, SizeOf(SHFileInfo), SHGFI_SYSICONINDEX or SHGFI_LARGEICON);
  ActualMailFile := '';
  SetMessageMenusEnabled;
  Image10.Cursor := crHandCursor;
  BKAttachments1 := TStringList.Create;
  BKAttachments2 := TStringList.Create;
  // Environment Options
  DefaultFont := TFont.Create;
  DefaultFont.Name := sMessageFont;
  DefaultFont.Size := iFontSize;
  DefaultFont.Color := iFontColor;
  DefaultFont.CharSet := iFontCharSet;
  // Form Position
  case IniFile.ReadInteger('Position', 'MainState', 1) of
    0, 1: begin
      WindowState := wsNormal;
      Width := IniFile.ReadInteger('Position', 'MainWidth', Width);
      Height := IniFile.ReadInteger('Position', 'MainHeight', Height);
      Top := IniFile.ReadInteger('Position', 'MainTop', Top);
      Left := IniFile.ReadInteger('Position', 'MainLeft', Left);
    end;
    2: WindowState := wsMaximized;
  end;
  // Splitter Position
  TreeView1.Width := IniFile.ReadInteger('Splitter', 'FolderView', TreeView1.Width);
  ListView1.Height := IniFile.ReadInteger('Splitter', 'MessageList', ListView1.Height);
  Panel9.Height := IniFile.ReadInteger('Splitter', 'MessageEdit', Panel9.Height);
  // ListView Order/Position
  if CheckBox1.Checked then begin
    ListView1.AutoSortStyle := assSmart;
  end;
  ListView1.ReadSettingsFromIniFile('MessageList', IniFile);
  // Printer
  if XPrint1.PrinterAvailable = False then begin
    Print1.Enabled := False;
    SpeedButton17.Enabled := False;
    PrinterSetup1.Enabled := False;
  end;
  // Resources
  ImageList1.ResourceLoad(rtBitmap, 'PX500', clFuchsia);
  ImageList3.ResourceLoad(rtBitmap, 'PX505', clNone);
  //Control positions
  Label4.Caption := '';
  Label4.Left := StatusBar1.Panels[0].Width+StatusBar1.Panels[1].Width+6;
  Label5.Caption := '';
  Label5.Left := StatusBar1.Panels[0].Width+StatusBar1.Panels[1].Width+StatusBar1.Panels[2].Width+22;
  PaintBox1.Left := Label4.Left-2;
  PaintBox1.Width := StatusBar1.Panels[2].Width-7;
  //Look and Feel
  ToolbarSeperators := TList.Create;
  if bOfficeFonts then Font.Name := sOfficeFontName;
  for I := 1 to iToolBarButtonCount do TSpeedButtonEx(FindComponent('SpeedButton'+IntToStr(I))).Comment := TSpeedButtonEx(FindComponent('SpeedButton'+IntToStr(I))).Caption;
  DefaultTlbButtonHeight := SpeedButton1.Height;
  DefaultTlbButtonWidth := SpeedButton1.Width;
  SetToolbarButtonOrder;
  bDrawBK := False;
  if FileExists(sToolbarBKBitmap) and bFlatButtons and (iColorDepth > 8) then begin
    Image4.Picture.LoadFromFile(sToolbarBKBitmap);
    bDrawBK := True;
  end;
  // Button Glyphs
  if ColorScheme or LowColor then begin
    SetBitmapToButton(SpeedButton4, 0);   SetBitmapToButton(SpeedButton5, 1);
    SetBitmapToButton(SpeedButton6, 2);   SetBitmapToButton(SpeedButton3, 3);
    SetBitmapToButton(SpeedButton2, 4);   SetBitmapToButton(SpeedButton9, 5);
    SetBitmapToButton(SpeedButton10, 6);  SetBitmapToButton(SpeedButton8, 7);
    SetBitmapToButton(SpeedButton7, 8);   SetBitmapToButton(SpeedButton1, 9);
    SetBitmapToButton(SpeedButton13, 14); SetBitmapToButton(SpeedButton14, 15);
    SetBitmapToButton(SpeedButton12, 16); SetBitmapToButton(SpeedButton17, 17);
    SetBitmapToButton(SpeedButton16, 18); SetBitmapToButton(SpeedButton15, 19);
    SetBitmapToButton(SpeedButton11, 20);
  end;
  GradientBmp := TBitmap.Create; GradientBmp.Width := Image5.Width; GradientBmp.Height := Image5.Height;
  CreateGradientBitmap(60, GradientBmp);
  Image5.Picture.Bitmap.Assign(GradientBmp);
  GradientBmp.Free;
  Bitmap := TBitmap.Create; Bitmap.Width := 48; Bitmap.Height := PaintBox1.Height;
  CreateGradientBitmap(0, Bitmap);
  AniBmp1 := TBitmap.Create; AniBmp1.Width := Bitmap.Width+6; AniBmp1.Height := Bitmap.Height;
  AniBmp2 := TBitmap.Create; AniBmp2.Width := Bitmap.Width+6; AniBmp2.Height := Bitmap.Height;
  AniBmp1.Canvas.Brush.Color := clBtnFace;
  AniBmp1.Canvas.FillRect(Rect(0, 0, AniBmp1.Width, AniBmp1.Height));
  AniBmp1.Canvas.CopyRect(Rect(3, 0, Bitmap.Width, Bitmap.Height), Bitmap.Canvas, Rect(0, 0, Bitmap.Width, Bitmap.Height));
  Bitmap.Free;
  E := 0;
  for I := AniBmp1.Width-1 downto 0 do begin
    C := AniBmp1.Canvas.Pixels[I, 0];
    AniBmp2.Canvas.Pen.Color := C;
    AniBmp2.Canvas.MoveTo(E, 0);
    AniBmp2.Canvas.LineTo(E, AniBmp1.Height);
    Inc(E);
  end;
  Image10.Hint := sHomepage;
  // Last folder
  for I := 0 to TreeView1.Items.Count-1 do
    if TreeView1.Items[I].StateIndex in [1,2] then
      if PFolderData(TreeView1.Items[I].Data)^.Path = sLastFolder then begin
        TreeView1.Items[I].Selected := True;
        TreeView1.Items[I].Focused := True;
      end;
  // Tray icon
  SHGetFileInfo(PChar(Application.Exename), 0, SHFileInfo, SizeOf(SHFileInfo), SHGFI_ICON or SHGFI_SMALLICON);
  TrayIcon := SHFileInfo.hIcon;;
  with NotifyIconData do begin
    cbSize := SizeOf(TNotifyIconData);
    Wnd := Handle;
    uID := 0;
    uFlags := NIF_MESSAGE+NIF_ICON+NIF_TIP;
    hIcon := TrayIcon;
    StrPCopy(szTip, 'Phoenix Mail');
    uCallbackMessage := WM_TASKICON;
  end;
  Shell_NotifyIcon(NIM_ADD, @NotifyIconData);
  // Explorer Drag Drop
  DragDropWndProcInstance := MakeObjectInstance(DragDropWndProc);
  DragDropDefWndProc := Pointer(GetWindowLong(ListView2.Handle,GWL_WNDPROC));
  SetWindowLong(ListView2.Handle, GWL_WNDPROC, LongInt(DragDropWndProcInstance));
  DragAcceptFiles(ListView2.Handle, True);
  //Menu
  //for I := 1 to 9 do
  //  ModifyMenu(PopupMenu6.Handle, I, MF_OWNERDRAW, 0, nil);
  //Strings
  DialUp1.LangStrList.Clear;
  DialUp1.LangStrList.Add(ListBox1.Items[64]);
  DialUp1.LangStrList.Add(ListBox1.Items[65]);
  DialUp1.LangStrList.Add(ListBox1.Items[87]);
  //Version
  sXMailer := 'Phoenix Mail ' + sMailerVer1;  //Standard Edition
  if MainForm.CheckBox2.Checked then
    sXMailer := 'Phoenix Mail ' + sMailerVer2;   //Developer Edition
  //Stuff
  IniFile.Free;
  Application.OnMinimize := AppMinimize;
  //Enabled
  CancelOnlineOperation1.Enabled := False;
  SpeedButton12.Enabled := False;
  //Timer
  OnlineThreadTerminated := False;
  OnlineThreadCounter := 0;
  Timer1.Enabled := True;
  Timer2.Enabled := True;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
  I: Integer;
begin
  try
    BKAttachments1.Free;
    BKAttachments2.Free;
    DefaultFont.Free;
  except end;
  // Tray icon
  Shell_NotifyIcon(NIM_DELETE, @NotifyIconData);
  DestroyIcon(TrayIcon);
  // Explorer Drag drop
  DragAcceptFiles(ListView2.Handle, False);
  SetWindowLong(ListView2.Handle, GWL_WNDPROC, LongInt(DragDropDefWndProc));
  FreeObjectInstance(DragDropWndProcInstance);
  // ListView
  IniFile := TIniFile.Create(sSettingsFile);
  ListView1.WriteSettingsToIniFile('MessageList', IniFile);
  // Form Position
  if WindowState = wsNormal then begin
    IniFile.WriteInteger('Position', 'MainState', 1);
    IniFile.WriteInteger('Position', 'MainWidth', Width);
    IniFile.WriteInteger('Position', 'MainHeight', Height);
    IniFile.WriteInteger('Position', 'MainTop', Top);
    IniFile.WriteInteger('Position', 'MainLeft', Left);
  end;
  if WindowState = wsMaximized then IniFile.WriteInteger('Position', 'MainState', 2);
  // Splitter Position
  IniFile.WriteInteger('Splitter', 'FolderView', TreeView1.Width);
  IniFile.WriteInteger('Splitter', 'MessageList', ListView1.Height);
  IniFile.WriteInteger('Splitter', 'MessageEdit', Panel9.Height);
  IniFile.Free;
  //Bevels
  try
    for I := 0 to ToolbarSeperators.Count-1 do TBevel(ToolbarSeperators.Items[I]).Free;
    ToolbarSeperators.Free;
  except end;
  AniBmp1.Free;
  AniBmp2.Free;
end;

procedure TMainForm.DoSaveMessage;
begin
  if SaveMessage = False then Exit;
  if FileExists(ActualMailFile) = False then Exit;
  RichEdit1.Lines.SaveToFile(sTempMessageFile);
  CurrentEMail.CompileMsgFileOnDisk(ActualMailFile);
  SaveMessage := False;
end;

procedure TMainForm.ScanForAccounts(TreeView: TTreeView);
var
  SearchRec: TSearchRec;
  Found, Level: Integer;
  Node: TTreeNode;
  F: TINIFile;
  AccountData: PAccountData;
  I: Integer;
  FolderData: PFolderData;

  procedure RecurseDirs(Dir: String);
  var
    SearchRec: TSearchRec;
    Found: Integer;
  begin
     Found := FindFirst(Dir+'*.*', $37, SearchRec);
     while Found = 0 do begin
       if (SearchRec.Attr and $10 = $10) and (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then begin
         if FileExists(Dir+SearchRec.Name+'\Folder.ini') then begin
           F := TINIFile.Create(Dir+SearchRec.Name+'\Folder.ini');
           New(FolderData);
           FolderData^.Path := Dir+SearchRec.Name+'\';
           FolderData^.Name := SearchRec.Name;
           FolderData^.Outbox := F.ReadBool('Folder', 'Outbox', False);
           FolderData^.Inbox := F.ReadBool('Folder', 'Inbox', False);
           FolderData^.Filter := F.ReadString('Filter', 'TakeIn', '');
           F.Free;
           while Node.Level <> (Level) do Node := Node.Parent;
           Node := TreeView.Items.AddChild(Node, FolderData^.Name);
           Node.Data := FolderData;
           if FolderData^.OutBox then begin
             Node.ImageIndex := 3;
             Node.SelectedIndex := 4;
           end else
             if FolderData^.InBox then begin
               Node.ImageIndex := 15;
               Node.SelectedIndex := 16;
             end else begin
               Node.ImageIndex := 1;
               Node.SelectedIndex := 2;
             end;
           Node.StateIndex := 2;
           Inc(Level);
           RecurseDirs(Dir+SearchRec.Name+'\');
         end;
       end;
       Found := FindNext(SearchRec);
     end;
     FindClose(SearchRec);
     Dec(Level);
  end;

begin
  TreeView.Items.Clear;
  //Accounts
  Node := TreeView1.Items.Add(TreeView1.TopItem, sAccountsCaption);
  Node.ImageIndex := 7;
  Node.SelectedIndex := 7;
  Node.StateIndex := 4;
  AccountsNode := Node;
  Found := FindFirst(sAccountRootFolder+'*.*', $37, SearchRec);
  while Found = 0 do begin
    if (SearchRec.Attr and $10 = $10) and (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then begin
      if FileExists(sAccountRootFolder+SearchRec.Name+'\Account.ini') then begin
        F := TIniFile.Create(sAccountRootFolder+SearchRec.Name+'\Account.ini');
        New(AccountData);
        AccountData^.Path := sAccountRootFolder+SearchRec.Name+'\';
        AccountData^.Name := F.ReadString('Account', 'Name', 'Account Name');
        AccountData^.FromMail := F.ReadString('From', 'EMail', '');
        AccountData^.FromDesc := F.ReadString('From', 'Name', '');
        AccountData^.ReplyMail := F.ReadString('ReplyTo', 'EMail', '');
        AccountData^.ReplyDesc := F.ReadString('ReplyTo', 'Name', '');
        AccountData^.POPServer := F.ReadString('POP3', 'Server', '');
        AccountData^.POPPort := F.ReadString('POP3', 'Port', '110');
        AccountData^.POPUser := F.ReadString('POP3', 'User', '');
        AccountData^.POPPass := MHDecrypt(F.ReadString('POP3', 'Password', ''));
        AccountData^.SMTPServer := F.ReadString('SMTP', 'Server', '');
        AccountData^.SMTPPort := F.ReadString('SMTP', 'Port', '25');
        AccountData^.Organization := F.ReadString('From', 'Organization', '');
        AccountData^.PromptPassword := F.ReadInteger('POP3', 'PromptPassword', 0);
        AccountData^.DoSMTP := F.ReadInteger('SMTP', 'DoSMTP', 1);
        AccountData^.DoPOP := F.ReadInteger('POP3', 'DoPOP', 1);
        AccountData^.StandardDownload := F.ReadInteger('POP3', 'StandardDownload', 0);
        AccountData^.KeepFilter := F.ReadString('Filter', 'Keep', '');
        AccountData^.DeleteFilter := F.ReadString('Filter', 'Delete', '');
        F.Free;
        Node := TreeView.Items.AddChild(AccountsNode, AccountData^.Name);
        Node.Data := AccountData;
        Node.ImageIndex := 0;
        Node.SelectedIndex := 0;
        Node.StateIndex := 1;
        Level := 1;
        RecurseDirs(sAccountRootFolder+SearchRec.Name+'\');
      end;
    end;
    Found := FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  //Repository
  Node := TreeView1.Items.Add(TreeView1.TopItem, sRepositoryCaption);
  Node.StateIndex := 5;
  Node.ImageIndex := 8;
  Node.SelectedIndex := 8;
  RepositoryNode := Node;
  //Trash bag
  Node := TreeView1.Items.Add(TreeView1.TopItem, sTrashBagCaption);
  Node.StateIndex := 3;
  TrashNode := Node;
  for I := 0 to TreeView1.Items.Count-1 do
    SetPXTreeNodeName(TreeView1.Items[I]);
end;

function TMainForm.GetActualAccount: TTreeNode;
var
  Node: TTreeNode;
begin
  Result := AccountsNode.GetFirstChild;
  if Assigned(TreeView1.Selected) then begin
    Node := TreeView1.Selected;
    if Node.Level < 1 then Exit;
    while Node.Level <> 1 do Node := Node.Parent;
    if Node.StateIndex = 1 then Result := Node;
  end;
end;

procedure TMainForm.SaveAccountDataToFile(Data: PAccountData);
var
  F: TINIFile;
begin
  F := TINIFile.Create(Data^.Path+'Account.ini');
  F.WriteString('Account', 'Name', Data^.Name);
  F.WriteString('From', 'EMail', Data^.FromMail);
  F.WriteString('From', 'Name', Data^.FromDesc);
  F.WriteString('ReplyTo', 'EMail', Data^.ReplyMail);
  F.WriteString('ReplyTo', 'Name', Data^.ReplyDesc);
  F.WriteString('POP3', 'Server', Data^.POPServer);
  F.WriteString('POP3', 'Port', Data^.POPPort);
  F.WriteString('POP3', 'User', Data^.POPUser);
  F.WriteString('POP3', 'Password', MHEncrypt(Data^.POPPass));
  F.WriteString('SMTP', 'Server', Data^.SMTPServer);
  F.WriteString('SMTP', 'Port', Data^.SMTPPort);
  F.WriteString('From', 'Organization', Data^.Organization);
  F.WriteInteger('POP3', 'PromptPassword', Data^.PromptPassword);
  F.WriteInteger('SMTP', 'DoSMTP', Data^.DoSMTP);
  F.WriteInteger('POP3', 'DoPOP', Data^.DoPOP);
  F.WriteInteger('POP3', 'StandardDownload', Data^.StandardDownload);
  F.WriteString('Filter', 'Keep', Data^.KeepFilter);
  F.WriteString('Filter', 'Delete', Data^.DeleteFilter);
  F.Free;
end;

procedure TMainForm.SaveFolderDataToFile(Data: PFolderData);
var
  F: TINIFile;
begin
  CreateFolder(Data^.Path);
  F := TINIFile.Create(Data^.Path+'Folder.ini');
  F.WriteBool('Folder', 'Outbox', Data^.Outbox);
  F.WriteBool('Folder', 'Inbox', Data^.Inbox);
  F.WriteString('Filter', 'TakeIn', Data^.Filter);
  F.Free;
end;

procedure TMainForm.ActualizeTrash;
var
  SearchRec: TSearchRec;
  Found, E: Integer;
begin
  E := 0;;
  Found := FindFirst(sTrashFolder+'*.*', faAnyFile, SearchRec);
  while Found = 0 do begin
    if UpperCase(ExtractFileExt(SearchRec.Name)) = '.MSG' then Inc(E);
    Found := FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  if E > 0 then begin
    TrashNode.ImageIndex := 6;
    TrashNode.SelectedIndex := 6;
  end else begin
    TrashNode.ImageIndex := 5;
    TrashNode.SelectedIndex := 5;
  end;
  E := 0;;
  Found := FindFirst(sRepositoryFolder+'*.*', faAnyFile, SearchRec);
  while Found = 0 do begin
    if UpperCase(ExtractFileExt(SearchRec.Name)) = '.MSG' then Inc(E);
    Found := FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  if E > 0 then begin
    RepositoryNode.ImageIndex := 8;
    RepositoryNode.SelectedIndex := 8;
  end else begin
    RepositoryNode.ImageIndex := 14;
    RepositoryNode.SelectedIndex := 14;
  end;
  TreeView1.Repaint;
end;

function TMainForm.GetUniqueAccountFolder(Name: String): String;
var
  S, T, K: String;
  I: integer;
begin
  T := 'a'+Copy(Name, 1, 5);
  for I := 1 to Length(T) do
    if not (T[I] in [' ','\','/','<','>',':','?','*','"','|',#19]) then
      K := K + T[I];
  T := K;
  repeat
    S := T;
    for I := 0 to 1 do
      S := S + Chr(Random(10)+48);
  until DirectoryExists(S) = False;
  Result := S;
end;

procedure TMainForm.New1Click(Sender: TObject);
var
  Node, FNode: TTreeNode;
  Data: PAccountData;
  Folder: PFolderData;
  StdIni: TIniFile;
begin
  AccountForm := TAccountForm.Create(Self);
  New(Data);
  Data^.Name := ListBox1.Items[3];
  Data^.POPPort := '110';
  Data^.SMTPPort := '25';
  Data^.DoSMTP := 1;
  Data^.DoPOP := 1;
  Data^.StandardDownload := 0;
  Data^.PromptPassword := 0;
  if (GetActualAccount = nil) and FileExists(sStandardAccountDataFile) then begin
    StdIni := TIniFile.Create(sStandardAccountDataFile);
    Data^.Name := StdIni.ReadString('Account', 'Name', ListBox1.Items[3]);
    Data^.FromMail := StdIni.ReadString('From', 'EMail', '');
    Data^.FromDesc := StdIni.ReadString('From', 'Name', '');
    Data^.ReplyMail := StdIni.ReadString('ReplyTo', 'EMail', '');
    Data^.ReplyDesc := StdIni.ReadString('ReplyTo', 'Name', '');
    Data^.POPServer := StdIni.ReadString('POP3', 'Server', '');
    Data^.POPPort := StdIni.ReadString('POP3', 'Port', '110');
    Data^.POPUser := StdIni.ReadString('POP3', 'User', '');
    Data^.POPPass := MHDecrypt(StdIni.ReadString('POP3', 'Password', ''));
    Data^.SMTPServer := StdIni.ReadString('SMTP', 'Server', '');
    Data^.SMTPPort := StdIni.ReadString('SMTP', 'Port', '25');
    Data^.Organization := StdIni.ReadString('From', 'Organization', '');
    Data^.PromptPassword := StdIni.ReadInteger('POP3', 'PromptPassword', 0);
    Data^.DoSMTP := StdIni.ReadInteger('SMTP', 'DoSMTP', 1);
    Data^.DoPOP := StdIni.ReadInteger('POP3', 'DoPOP', 1);
    Data^.StandardDownload := StdIni.ReadInteger('POP3', 'StandardDownload', 0);
    Data^.KeepFilter := StdIni.ReadString('Filter', 'Keep', '');
    Data^.DeleteFilter := StdIni.ReadString('Filter', 'Delete', '');
    StdIni.Free;
  end;
  AccountForm.CreateNewAccount := True;
  AccountForm.LoadAccountData(Data);
  if AccountForm.ShowModal = mrOK then begin
    AccountForm.SaveAccountData(Data);
    SaveAccountDataToFile(Data);
    Node := TreeView1.Items.AddChild(AccountsNode, Data^.Name);
    Node.Data := Data;
    Node.StateIndex := 1;
    Node.ImageIndex := 0;
    Node.SelectedIndex := 0;
    // Child folders
    New(Folder); Folder^.Name := ListBox1.Items[4]; Folder^.Outbox := True; Folder^.Inbox := False;
    Folder^.Path := Data^.Path+'\'+Folder.Name+'\'; CreateFolder(Folder^.Path); SaveFolderDataToFile(Folder);
    FNode := TreeView1.Items.AddChild(Node, Folder^.Name);
    FNode.Data := Folder; FNode.StateIndex := 2; FNode.ImageIndex := 3; FNode.SelectedIndex := 4;

    New(Folder); Folder^.Name := ListBox1.Items[5]; Folder^.Outbox := False; Folder^.Inbox := True;
    Folder^.Path := Data^.Path+'\'+Folder.Name+'\'; CreateFolder(Folder^.Path); SaveFolderDataToFile(Folder);
    FNode := TreeView1.Items.AddChild(Node, Folder^.Name);
    FNode.Data := Folder; FNode.StateIndex := 2; FNode.ImageIndex := 1; FNode.SelectedIndex := 2;

    New(Folder); Folder^.Name := ListBox1.Items[6]; Folder^.Outbox := False; Folder^.Inbox := False;
    Folder^.Path := Data^.Path+'\'+Folder.Name+'\'; CreateFolder(Folder^.Path); SaveFolderDataToFile(Folder);
    FNode := TreeView1.Items.AddChild(Node, Folder^.Name);
    FNode.Data := Folder; FNode.StateIndex := 2; FNode.ImageIndex := 1; FNode.SelectedIndex := 2;

    Node.Expanded := True;
    TreeView1.SetFocus;
    Node.Selected := True;
    TreeView1.Selected := Node;
    TreeView1.AlphaSort;
  end else
    Dispose(Data);
  AccountForm.Free;
  SetAccountMenusEnabled(False);
  SetMessageMenusEnabled;
  ActualizeStatusBar;
end;

procedure TMainForm.TreeView1Deletion(Sender: TObject; Node: TTreeNode);
var
  AccountData: PAccountData;
  FolderData: PFolderData;
begin
  if Assigned(Node.Data) then begin
    if Node.StateIndex = 1 then begin
      AccountData := Node.Data;
      Dispose(AccountData);
    end;
    if Node.StateIndex = 2 then begin
      FolderData := Node.Data;
      Dispose(FolderData);
    end;
  end;
end;

procedure TMainForm.Properties1Click(Sender: TObject);
var
  Node: TTreeNode;
  Data: PAccountData;
begin
  Node := GetActualAccount;
  if Assigned(Node) then
    if Assigned(Node.Data) then begin
      AccountForm := TAccountForm.Create(Self);
      Data := Node.Data;
      AccountForm.CreateNewAccount := False;
      AccountForm.LoadAccountData(Data);
      if AccountForm.ShowModal = mrOK then begin
        AccountForm.SaveAccountData(Data);
        SaveAccountDataToFile(Data);
        SetPXTreeNodeName(Node);
        TreeView1.AlphaSort;
      end;
      AccountForm.Free;
    end;
end;

procedure TMainForm.Properties2Click(Sender: TObject);
var
  Node: TTreeNode;
  Data: PFolderData;
  S: String;
begin
  Node := TreeView1.Selected;
  if Assigned(Node) then
    if Node.StateIndex = 2 then
      if Assigned(Node.Data) then begin
        FolderForm := TFolderForm.Create(Self);
        Data := Node.Data;
        S := Data^.Path;
        FolderForm.LoadFolderData(Data);
        if FolderForm.ShowModal = mrOK then begin
          FolderForm.SaveFolderData(Data);
          MoveFolder(S, Data^.Path);
          SaveFolderDataToFile(Data);
           if Data^.OutBox then begin
             Node.ImageIndex := 3;
             Node.SelectedIndex := 4;
           end else
             if Data^.InBox then begin
               Node.ImageIndex := 15;
               Node.SelectedIndex := 16;
             end else begin
               Node.ImageIndex := 1;
               Node.SelectedIndex := 2;
             end;
           SetPXTreeNodeName(Node);
           TreeView1.AlphaSort;
        end;
        FolderForm.Free;
        Node := TreeView1.Selected;
        TreeView1.Selected := nil;
        TreeView1.Selected := Node
      end;
end;

procedure TMainForm.New2Click(Sender: TObject);
var
  Node: TTreeNode;
  Data: PFolderData;
begin
  if Assigned(TreeView1.Selected) then Node := TreeView1.Selected else Node := TreeView1.TopItem;
  if Assigned(Node) then
    if Node.StateIndex in [1, 2] then
      if Assigned(Node.Data) then begin
        FolderForm := TFolderForm.Create(Self);
        New(Data);
        Data^.Name := ListBox1.Items[7];
        Data^.Outbox := False;
        Data^.Inbox := False;
        Data^.Filter := '';
        if Node.StateIndex = 2 then
          Data^.Path := PFolderData(Node.Data)^.Path+'##@@  @@##\'
        else
          Data^.Path := PAccountData(Node.Data)^.Path+Data^.Name+'##@@  @@##\';
        FolderForm.LoadFolderData(Data);
        if FolderForm.ShowModal = mrOK then begin
          FolderForm.SaveFolderData(Data);
          CreateFolder(Data^.Path);
          SaveFolderDataToFile(Data);
          Node := TreeView1.Items.AddChild(Node, Data^.Name);
          Node.Data := Data;
          Node.StateIndex := 2;
          if Data^.OutBox then begin
             Node.ImageIndex := 3;
             Node.SelectedIndex := 4;
           end else begin
             Node.ImageIndex := 1;
             Node.SelectedIndex := 2;
           end;
           Node.Parent.Expanded := True;
           TreeView1.SetFocus;
           Node.Selected := True;
           TreeView1.Selected := node;
        end else
          Dispose(Data);
        FolderForm.Free;
        TreeView1.AlphaSort;
      end;
end;

procedure TMainForm.TreeView1Edited(Sender: TObject; Node: TTreeNode; var S: String);
var
  AccountData: PAccountData;
  FolderData: PFolderData;
  OldDir: String;
  I: Integer;
  IniFile: TIniFile;
begin
  Exit;
  //not editable anymore...
  for I := 1 to Length(S) do
    if S[I] in ['\','/','<','>',':','?','*','"','|',#19] then begin
      MessageDlg(MainForm.ListBox1.Items[44], mtWarning, [mbOK], 0);
      S := GetPXTreeNodeName(Node);
      Exit;
    end;
  if Node.StateIndex = 1 then begin
    AccountData := Node.Data;
    AccountData^.Name := S;
    SaveAccountDataToFile(AccountData);
  end;
  if Node.StateIndex = 2 then begin
    FolderData := Node.Data;
    OldDir := FolderData^.Path;
    FolderData^.Name := S;
    FolderData^.Path := GetParentFolder(FolderData.Path)+FolderData^.Name+'\';
    MoveFolder(OldDir, FolderData^.Path);
    SaveFolderDataToFile(FolderData);
  end;
  IniFile := TIniFile.Create(sSettingsFile);
  if Node.StateIndex = 3 then begin
    IniFile.WriteString('Trash', 'Name', S);
  end;
  if Node.StateIndex = 4 then begin
    IniFile.WriteString('Accounts', 'Name', S);
  end;
  if Node.StateIndex = 5 then begin
    IniFile.WriteString('Repository', 'Name', S);
  end;
  IniFile.Free;
  SetPXTreeNodeName(Node);
  TreeView1.AlphaSort;
end;

procedure TMainForm.Delete1Click(Sender: TObject);
var
  Node: TTreeNode;
  Data: PFolderData;
  S: String;
begin
  Node := TreeView1.Selected;
  if Assigned(Node) then
    if Node.StateIndex = 2 then
      if Assigned(Node.Data) then begin
        S := Format(ListBox1.Items[8], [GetPXTreeNodeName(Node)]);
        if MessageDlg(S, mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
          Data := Node.Data;
          DeleteFolder(Data^.Path, sTrashFolder);
          Node.Delete;
          ActualizeTrash;
          TreeView1.AlphaSort;
        end;
      end;
end;

procedure TMainForm.Delete2Click(Sender: TObject);
var
  Node: TTreeNode;
  Data: PAccountData;
begin
  Node := GetActualAccount;
  if Assigned(Node) then
    if Assigned(Node.Data) then begin
      if MessageDlg(Format(ListBox1.Items[9], [GetPXTreeNodeName(Node)]), mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
        Data := Node.Data;
        DeleteFolder(Data^.Path, sTrashFolder);
        Node.Delete;
        ActualizeTrash;
        TreeView1.AlphaSort;
        SetAccountMenusEnabled(False);
        SetMessageMenusEnabled;
        ActualizeStatusBar;
      end;
    end;
end;

procedure TMainForm.Enhanced1Click(Sender: TObject);
begin
  EmptyTrashBin1.Enabled := False;
  EmptyTrashBin1.Caption := Format(ListBox1.Items[84], [GetPXTreeNodeName(TrashNode)]);
  EmptyTrashBin2.Caption := Format(ListBox1.Items[84], [GetPXTreeNodeName(TrashNode)]);
  EmptyRepository1.Enabled := False;
  EmptyRepository1.Caption := Format(ListBox1.Items[85], [GetPXTreeNodeName(RepositoryNode)]);
  EmptyRepository2.Caption := Format(ListBox1.Items[85], [GetPXTreeNodeName(RepositoryNode)]);
  if TrashNode.ImageIndex = 6 then begin
    EmptyTrashBin1.Enabled := True;
    EmptyTrashBin2.Enabled := True;
  end;
  if RepositoryNode.ImageIndex = 8 then begin
    EmptyRepository1.Enabled := True;
    EmptyRepository2.Enabled := True;
  end;
end;

procedure TMainForm.EmptyTrashBin1Click(Sender: TObject);
var
  SearchRec: TSearchRec;
  Found: Integer;
begin
  Screen.Cursor := crHourGlass;
  Application.ProcessMessages;
  Found := FindFirst(sTrashFolder+'*.*', faAnyFile, SearchRec);
  while Found = 0 do begin
    SetFileAttr(sTrashFolder+SearchRec.Name, False, True, False, False);
    DeleteFile(sTrashFolder+SearchRec.Name);
    Found := FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  TreeView1Change(Self, TreeView1.Selected);
  ActualizeTrash;
  TreeView1.Invalidate;
end;

procedure TMainForm.Folder1Click(Sender: TObject);
var
  Node: TTreeNode;
begin
  New2.Enabled := False;
  Delete1.Enabled := False;
  Properties2.Enabled := False;
  Node := TreeView1.Selected;
  if Assigned(Node) then
    if Assigned(Node.Data) then begin
      if Node.StateIndex = 2 then begin
        New2.Enabled := True;
        Delete1.Enabled := True;
        Properties2.Enabled := True;
      end;
      if Node.StateIndex = 1 then begin
        New2.Enabled := True;
      end;
    end;
end;

procedure TMainForm.Account1Click(Sender: TObject);
var
  Node: TTreeNode;
begin
  FetchMails1.Enabled := False;
  SendMail1.Enabled := False;
  Delete2.Enabled := False;
  Properties1.Enabled := False;
  Node := GetActualAccount;
  if Assigned(Node) then
    if Assigned(Node.Data) then begin
      if AreWeOnline = False then begin
        FetchMails1.Enabled := True;
        SendMail1.Enabled := True;
      end;
      Delete2.Enabled := True;
      Properties1.Enabled := True;
    end;
end;

procedure TMainForm.TreeView1DragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := False;
  if Source = TreeView1 then
    if TreeView1.Selected.StateIndex = 2 then Accept := True;
  if Source = ListView1 then Accept := True;
end;

procedure TMainForm.TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
var
  Node: TTreeNode;
  Data: PFolderData;
  Item: TListItem;
  S: String;
  I, E: Integer;

  procedure SetSubNotesPath(Node: TTreeNode);
  var
    I: Integer;
  begin
    for I := 0 to Node.Count-1 do begin
      PFolderData(Node.Item[I].Data)^.Path := PFolderData(Node.Item[I].Parent.Data)^.Path+GetPXTreeNodeName(Node.Item[I])+'\';
      if Node.Count > 0 then SetSubNotesPath(Node.Item[I]);
    end;
  end;

begin
  ListView1.Invalidate;
  TreeView1.Invalidate;
  Splitter1.Invalidate;
  Node := TreeView1.GetNodeAt(X, Y);
  if Node = nil then Exit;
  if Node = TreeView1.Selected then Exit;
  if SaveMessage then DoSaveMessage;
  if Node.StateIndex = 1 then
    S := PAccountData(Node.Data)^.Path;
  if Node.StateIndex = 2 then
    S := PFolderData(Node.Data)^.Path;
  if Node.StateIndex = 3 then
    S := sTrashFolder;
  if Node.StateIndex = 5 then
    S := sRepositoryFolder;
  // Drag Folder
  if Source = TreeView1 then begin
    if TreeView1.Selected = nil then Exit;
    if TreeView1.Selected.StateIndex <> 2 then Exit;
    if Node.StateIndex in [4, 5] then Exit;
    Data := TreeView1.Selected.Data;
    if Node.StateIndex = 3 then begin
      if MessageDlg(Format(ListBox1.Items[8], [GetPXTreeNodeName(TreeView1.Selected)]), mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
        DeleteFolder(PFolderData(TreeView1.Selected.Data)^.Path, sTrashFolder);
        TreeView1.Selected.Delete;
        ActualizeTrash;
        TreeView1.AlphaSort;
      end;
      Exit;
    end;
    S := S + Data^.Name+ '\';
    if Data^.Path = S then Exit;
    if DirectoryExists(S) then begin
      MessageDlg(Format(ListBox1.Items[10], [Data^.Name]), mtWarning, [mbOK], 0);
      Exit;
    end;
    MoveFolder(Data^.Path, S);
    Data^.Path := S;
    Screen.Cursor := crHourGlass;
    MoveTreeViewNode(TreeView1, TreeView1.Selected, Node);
    Screen.Cursor := crDefault;
    //TreeView1.Selected.MoveTo(Node, naAddChildFirst);
    //SetSubNotesPath(TreeView1.Selected);
    //TreeView1.AlphaSort;
  end;
  // Drag Message
  if Source = ListView1 then begin
    if Node.StateIndex = 4 then Exit;
    I := 0; E := ListView1.Items.Count-1;
    while I <= E do begin
      if ListView1.Items[I].Selected then begin
        Item := ListView1.Items[I];
        //SetFileAttr(Item.SubItems[4], False, True, False, False);
        //CopyFile(PChar(Item.SubItems[4]), PChar(S+ExtractFileName(Item.SubItems[4])), False);
        FileCopy(nil, Item.SubItems[4], S+ExtractFileName(Item.SubItems[4]));
        SetFileAttr(Item.SubItems[4], False, True, False, False);

        DeleteFile(Item.SubItems[4]);
        Item.Delete;
        Dec(I); Dec(E);
      end;
      Inc(I);
    end;
    ListView1MouseUp(Self, mbLeft, [ssLeft], 0, 0);
    Application.ProcessMessages;
    SetPXTreeNodeName(Node);
    SetPXTreeNodeName(TreeView1.Selected);
    ActualizeStatusBar;
    ActualizeTrash;
  end;
end;

procedure TMainForm.Properties3Click(Sender: TObject);
begin
  if TreeView1.Selected = nil then Exit;
  if TreeView1.Selected.StateIndex = 1 then
    Properties1.OnClick(Self);
  if TreeView1.Selected.StateIndex = 2 then
    Properties2.OnClick(Self);
end;

procedure TMainForm.PopupMenu1Popup(Sender: TObject);
var
  Node: TTreeNode;
begin
  NewFolder1.Enabled := False;
  DeleteFolder1.Enabled := False;
  EmptyTrashBin2.Enabled := False;
  EmptyRepository2.Enabled := False;
  Properties3.Enabled := False;
  Enhanced1.OnClick(Self);
  if TreeView1.Selected = nil then Exit;
  Node := TreeView1.Selected;
  if Node.StateIndex = 1 then begin
    NewFolder1.Enabled := True;
    Properties3.Enabled := True;
  end;
  if Node.StateIndex = 2 then begin
    NewFolder1.Enabled := True;
    DeleteFolder1.Enabled := True;
    Properties3.Enabled := True;
  end;
  TreeView1.Selected := Node;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FetchMails1Click(Sender: TObject);
begin
  OnlineSession(1);
end;

procedure TMainForm.TreeView1Change(Sender: TObject; Node: TTreeNode);
var
  Dir: String;
  SearchRec: TSearchRec;
  Item: TListItem;
  Found: Integer;
  Outbox: Boolean;
begin
  if csDestroying in ComponentState then Exit;
  Screen.Cursor := crHourGlass;
  sLastFolder := '';
  if SaveMessage then DoSaveMessage;
  Panel6.Visible := False;
  ActualMailFile := '';
  ListView1.BeginUpdate;
  ListView1.Items.Clear;
  ListView2.Items.Clear;
  RichEdit1.Lines.Clear;
  RichEdit1.Enabled := False;
  ListView2.Enabled := False;
  Dir := '';
  if (Node = nil) or (Node.StateIndex = 4) then begin
    ListView1.EndUpdate;
    ActualizeStatusBar;
    Screen.Cursor := crDefault;
    Exit;
  end;
  OutBox := False;
  if Node.StateIndex = 1 then
    Dir := PAccountData(Node.Data)^.Path;
  if Node.StateIndex = 2 then begin
    Dir := PFolderData(Node.Data)^.Path;
    OutBox := PFolderData(Node.Data)^.Outbox;
  end;
  if Node.StateIndex = 3 then
    Dir := sTrashFolder;
  if Node.StateIndex = 5 then begin
    OutBox := True;
    Dir := sRepositoryFolder;
  end;
  if OutBox then
    Listview1.Columns.Items[2].Caption := ListBox1.Items[11]
  else
    Listview1.Columns.Items[2].Caption := ListBox1.Items[12];
  sLastFolder := Dir;
  Found := FindFirst(Dir+'*.*', faAnyFile, SearchRec);
  while Found = 0 do begin
    if UpperCase(ExtractFileExt(SearchRec.Name)) = '.MSG' then begin
      Item := ListView1.Items.Add;
      CurrentEMail.ParseMail(Dir+SearchRec.Name, True);
      Item.ImageIndex := -1;
      if FileGetAttr(Dir+SearchRec.Name) and faArchive = 0 then begin
        if (LowerCase(CurrentEMail.Priority) = 'low') then Item.ImageIndex := 9;
        if (LowerCase(CurrentEMail.Priority) = 'normal') then Item.ImageIndex := 10;
        if (LowerCase(CurrentEMail.Priority) = 'high') then Item.ImageIndex := 11;
      end;
      Item.SubItems.Add(CurrentEMail.Subject);
      if OutBox then begin
        Item.SubItems.Add(GetCommataStringReceiver);
      end else
        Item.SubItems.Add(CurrentEMail.From);
      Item.SubItems.Add(DateToStr(CurrentEMail.ADate));
      Item.SubItems.Add(TimeToStr(CurrentEMail.ATime));
      Item.SubItems.Add(Dir+SearchRec.Name);  // invisible
    end;
    Found := FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  ListView1.EndUpdate;
  ActualizeStatusBar;
  ActualMailFile := '';
  ListView1.Resort;
  SetMessageMenusEnabled;
  SaveMessage := False;
  Screen.Cursor := crDefault;
end;

procedure TMainForm.Open1Click(Sender: TObject);
var
  I: Integer;
  A: array[0..MAX_PATH] of Char;
  S: String;
begin
  if ListView2.SelCount = 0 then Exit;
  for I := 0 to ListView2.Items.Count-1 do
    if ListView2.Items[I].Selected then
      if ShellExecute(Handle, 'open', PChar(sTemporaryFolder+ListView2.Items[I].Caption), '', PChar(sTemporaryFolder), SW_SHOWNORMAL) <= 32 then begin
        GetSystemDirectory(A, MAX_PATH);
        S := A;
        S := MakeValidDirName(S)+'Viewers\Quikview.exe';
        ShellExecute(Handle, 'open', PChar(S), PChar(sTemporaryFolder+ListView2.Items[I].Caption), PChar(sTemporaryFolder), SW_SHOWNORMAL);
      end;
end;

procedure TMainForm.Saveas1Click(Sender: TObject);
var
  I: Integer;
  D: String;
begin
  if ListView2.SelCount = 0 then Exit;
  DirectoryForm := TDirectoryForm.Create(Self);
  if DirectoryExists(sLastAttSaveDir) then
    DirectoryForm.RzDirectoryListBox1.Directory := sLastAttSaveDir
  else
    DirectoryForm.RzDirectoryListBox1.Directory := ExtractFileDir(Application.Exename);
  if DirectoryForm.ShowModal = mrOK then begin
    D := MakeValidDirname(DirectoryForm.RzDirectoryListBox1.Directory);
    sLastAttSaveDir := D;
    for I := 0 to ListView2.Items.Count-1 do
      if ListView2.Items[I].Selected then begin
        SetFileAttr(sTemporaryFolder+ListView2.Items[I].Caption, False, True, False, False);
        if FileExists(D+ListView2.Items[I].Caption) then begin
          case MessageDlg(Format(ListBox1.Items[13], [ListView2.Items[I].Caption]), mtWarning, [mbYes, mbNo, mbCancel], 0) of
            mrYes: CopyFile(PChar(sTemporaryFolder+ListView2.Items[I].Caption), PChar(D+ListView2.Items[I].Caption), False);
            mrNo: ;//nothing
            mrCancel: Exit;
          end;
        end else
          CopyFile(PChar(sTemporaryFolder+ListView2.Items[I].Caption), PChar(D+ListView2.Items[I].Caption), False);
      end;
  end;
  DirectoryForm.Free;
end;

procedure TMainForm.AddAttachment(Filename: String);
var
  Item: TListItem;
  SHFileInfo: TSHFileInfo;
begin
  Item := ListView2.Items.Add;
  Item.Caption := ExtractFileName(Filename);
  SHGetFileInfo(PChar(Filename), 0, SHFileInfo, SizeOf(SHFileInfo), SHGFI_SYSICONINDEX or SHGFI_LARGEICON);
  Item.ImageIndex := SHFileInfo.iIcon;
  CopyFile(PChar(Filename), PChar(sTemporaryFolder+Item.Caption), False);
  SaveMessage := True;
  ActualizeStatusBar;
end;

procedure TMainForm.Add1Click(Sender: TObject);
var
  I: Integer;
begin
  if (ListView1.SelCount <> 1) or (ListView1.Selected = nil) then Exit;
  if DirectoryExists(sLastAttOpenDir) then
    OpenDialog1.InitialDir := sLastAttOpenDir
  else
    OpenDialog1.InitialDir := ExtractFileDir(Application.Exename);
  if OpenDialog1.Execute then begin
    sLastAttOpenDir := ExtractFileDir(OpenDialog1.Filename);
    for I := 0 to OpenDialog1.Files.Count-1 do begin
      AddAttachment(OpenDialog1.Files[I]);
    end;
  end;
end;

procedure TMainForm.Delete3Click(Sender: TObject);
var
  I: Integer;
label J;
begin
  if ListView2.SelCount = 0 then Exit;
  J:
  for I := 0 to ListView2.Items.Count-1 do
    if ListView2.Items[I].Selected then begin
      case MessageDlg(Format(ListBox1.Items[14], [ListView2.Items[I].Caption]), mtWarning, [mbYes, mbNo, mbCancel], 0) of
        mrYes: begin
          DeleteFile(PChar(sTemporaryFolder+ListView2.Items[I].Caption));
          ListView2.Items[I].Delete;
          SaveMessage := True;
          GoTo J;
        end;
        mrNo: ;//nothing
        mrCancel: Exit;
      end;
    end;
  ActualizeStatusBar
end;

procedure TMainForm.ToggleUnreadFlag1Click(Sender: TObject);
var
  Item: TListItem;
  I: Integer;
begin
  ReadCounter := 0;
  for I := 0 to ListView1.Items.Count-1 do
    if ListView1.Items[I].Selected then begin
      Item := ListView1.Items[I];
      if Item.ImageIndex = -1 then begin
        FileSetAttr(Item.SubItems[4], 0);
        if (LowerCase(CurrentEMail.Priority) = 'low') then Item.ImageIndex := 9;
        if (LowerCase(CurrentEMail.Priority) = 'normal') then Item.ImageIndex := 10;
        if (LowerCase(CurrentEMail.Priority) = 'high') then Item.ImageIndex := 11;
      end else begin
        Item.ImageIndex := -1;
        FileSetAttr(Item.SubItems[4], faArchive);
      end;
    end;
  SetPXTreeNodeName(TreeView1.Selected);
  ActualizeStatusBar;
end;

procedure TMainForm.Properties4Click(Sender: TObject);
var
  Item: TListItem;
  Node: TTreeNode;
  Outbox: Boolean;
  S: String;
begin
  if (ListView1.SelCount <> 1) or (ListView1.Selected = nil) then Exit;
  Item := ListView1.Selected;
  Node := TreeView1.Selected;
  if Node = nil then Exit;
  if Item = nil then Exit;
  Outbox := False;
  if Node.StateIndex = 2 then begin
    if PFolderData(Node.Data)^.OutBox then begin
      Outbox := True;
      MailOptionsForm.SetFields(0)
    end else
      MailOptionsForm.SetFields(1);
    Node := GetActualAccount;
  end else begin
    MailOptionsForm.SetFields(1);
  end;
  if Node = nil then Exit;
  S := GetPXTreeNodeName(Node);
  //MailOptionsForm.Label12.Caption := S;
  if MailOptionsForm.ShowModal = mrOK then begin
    Item.SubItems[0] := CurrentEMail.Subject;
    if OutBox then begin
      Item.SubItems[1] := GetCommataStringReceiver;
    end else
      Item.SubItems[1] := CurrentEMail.From;
    Item.SubItems[2] := DateToStr(CurrentEMail.ADate);
    Item.SubItems[3] := TimeToStr(CurrentEMail.ATime);
  end;
end;

procedure TMainForm.RichEdit1Change(Sender: TObject);
begin
  SaveMessage := True;
end;

procedure TMainForm.TreeView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Ord(Key) = 46 then Delete1Click(Self);
end;

procedure TMainForm.Delete4Click(Sender: TObject);
var
  Item: TListItem;
  S: String;
  I, E: Integer;
begin
  if ListView1.Selected = nil then Exit;
  I := 0; E := ListView1.Items.Count-1;
  while I <= E do begin
    if ListView1.Items[I].Selected then begin
      Item := ListView1.Items[I];
       S := Item.SubItems[4];
       SetFileAttr(S, False, True, False, False);
       if not (MakeValidDirName(ExtractFileDir(S)) = sTrashFolder) then
         CopyFile(PChar(S), PChar(sTrashFolder+ExtractFileName(S)), False);
      DeleteFile(S);
      Item.Delete;
      Dec(I); Dec(E);
    end;
    Inc(I);
  end;
  ListView1MouseUp(Self, mbLeft, [ssLeft], 0, 0);
  SetPXTreeNodeName(TreeView1.Selected);
  ActualizeStatusBar;
  ActualizeTrash;
end;

procedure TMainForm.UpdateListView;
var
  SearchRec: TSearchRec;
  Found: Integer;
  SHFileInfo: TSHFileInfo;
  Item: TListItem;
  ScanForVirus: Boolean;
  S: String;
  I: Integer;
begin
  Panel6.Visible := False;
  ReadCounter := 0;
  if SaveMessage then DoSaveMessage;
  RichEdit1.Lines.BeginUpdate;
  ListView2.Items.Clear;
  RichEdit1.Lines.Clear;
  ActualMailFile := '';
  ClearFolder(sTemporaryFolder);
  Item := ListView1.Selected;
  if (ListView1.SelCount > 1) or (Item = nil) or (csDestroying in ComponentState) then begin
    RichEdit1.Lines.EndUpdate;
    RichEdit1.Enabled := False;
    ListView2.Enabled := False;
    Exit;
  end;
  Screen.Cursor := crHourGlass;
  Application.ProcessMessages;
  RichEdit1.DefAttributes.Assign(DefaultFont);
  RichEdit1.SelAttributes.Assign(DefaultFont);
  CurrentEMail.ParseMail(Item.SubItems[4], False);
  ActualMailFile := Item.SubItems[4];
  ScanForVirus := False;
  if (FileGetAttr(Item.SubItems[4]) and faArchive) = 0 then
    ScanForVirus := True;
  //Text
  if FileExists(sTempMessageFile) then begin
    if CurrentEMail.MsgType = mtText then RichEdit1.Lines.LoadFromFile(sTempMessageFile) else
    if CurrentEMail.MsgType = mtHtml then RichEdit1.Lines.LoadFromFile(sTempMessageFile) else
    if CurrentEMail.MsgType = mtRich then RichEdit1.Lines.LoadFromFile(sTempMessageFile);
  end;
  //Attachments
  Found := FindFirst(sTemporaryFolder+'*.*', faReadOnly+faHidden+faArchive+faSysFile, SearchRec);
  while Found = 0 do begin
    if sTemporaryFolder+SearchRec.Name <> sTempMessageFile then begin
      Item := ListView2.Items.Add;
      Item.Caption := SearchRec.Name;
      SHGetFileInfo(PChar(sTemporaryFolder+SearchRec.Name), 0, SHFileInfo, SizeOf(SHFileInfo), SHGFI_SYSICONINDEX or SHGFI_LARGEICON);
      Item.ImageIndex := SHFileInfo.iIcon;
    end;
    Found := FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  // Virus Scan
  if (ListView2.Items.Count > 0) and (sVirusProg <>'') and (ScanForVirus = True) then begin
    if bVirusMin then
      ShellExecute(Handle, 'open', PChar(sVirusProg), PChar(sTemporaryFolder+' '+sVirusParams), PChar(sTemporaryFolder), SW_MINIMIZE)
    else
      ShellExecute(Handle, 'open', PChar(sVirusProg), PChar(sTemporaryFolder+' '+sVirusParams), PChar(sTemporaryFolder), SW_SHOWNORMAL);
  end;
  //X-Mailer
  S := 'Unknown Mail Client';
  for I := 0 to CurrentEMail.Fields.Count-1 do
    if LowerCase(CurrentEMail.Fields[I]) = 'x-mailer' then
      S := CurrentEMail.FieldValues[I];
  Label3.Caption := S;
  Panel6.Width := Label3.Width+8;
  Panel6.Left := RichEdit1.Width-20-Panel6.Width;
  Panel6.Top := RichEdit1.Top+4;
  if CheckBox2.Checked then Panel6.Visible := True;
  //End
  RichEdit1.Lines.EndUpdate;
  RichEdit1.Enabled := True;
  ListView2.Enabled := True;
  SaveMessage := False;
  Screen.Cursor := crDefault;
end;

function TMainForm.NewMessage(ShowDlg, Signat: Boolean; ASubject, ATo, AFrom: String; NewText: TStringList): Boolean;
var
  Item: TListItem;
  Node, FNode: TTreeNode;
  S: String;
  Outbox: Boolean;
  I, E, Y: Integer;
  SL, NL: TStringList;
  P: TPoint;

  procedure GetSubNotes(Node: TTreeNode);
  var
    I: Integer;
  begin
    for I := 0 to Node.Count-1 do begin
      if PFolderData(Node.Item[I].Data)^.Outbox then
        FNode := Node.Item[I];
      if Node.Count > 0 then GetSubNotes(Node.Item[I]);
    end;
  end;

begin
  Result := False;
  // get outbox folder
  Node := GetActualAccount;
  if Node = nil then Exit;
  FNode := nil;
  GetSubNotes(Node);
  // clear up
  if SaveMessage then DoSaveMessage;
  ClearFolder(sTemporaryFolder);
  with CurrentEMail do begin
    ToReceiver.Clear;
    if ATo <> '' then CommataStringToStringList(ATo, ToReceiver);
    CC.Clear;
    BCC.Clear;
    Fields.Clear;
    FieldValues.Clear;
    if AFrom = '' then
      From := PAccountData(Node.Data)^.FromDesc+' <'+PAccountData(Node.Data)^.FromMail+'>'
    else
      From := AFrom;
    Priority := 'Normal';
    Subject := ASubject;
    Keywords := '';
    ADate := Date;
    ATime := Time;
    if PAccountData(Node.Data)^.Organization <> '' then begin
      Fields.Add('Organization');
      FieldValues.Add(PAccountData(Node.Data)^.Organization);
    end;
    if AFrom = '' then
      if PAccountData(Node.Data)^.ReplyMail <> '' then begin
        Fields.Add('Reply-to');
        FieldValues.Add(PAccountData(Node.Data)^.ReplyDesc+' <'+PAccountData(Node.Data)^.ReplyMail+'>');
      end;
    Fields.Add('X-mailer');
    FieldValues.Add(sXMailer);
  end;
  // get outbox path
  Outbox := False;
  if FNode = nil then
    S := PAccountData(Node.Data)^.Path
  else begin
    S := PFolderData(FNode.Data)^.Path;
    Outbox := PFolderData(FNode.Data)^.Outbox;
  end;
  S := S + GetUniqueMailName + '.msg';
  // prepare dialog
  MailOptionsForm.SetFields(0);
  MailOptionsForm.LoadMailHeader;
  //show dialog?
  if ShowDlg then begin
    if MailOptionsForm.ShowModal <> mrOK then begin
      SaveMessage := False;
      UpdateListView;
      SaveMessage := False;
      Screen.Cursor := crDefault;
      Exit;
    end;
  end;
  Screen.Cursor := crHourGlass;
  // switch to outbox folder
  SaveMessage := False;
  for I := 0 to ListView1.Items.Count-1 do
    ListView1.Items[I].Selected := False;
  SaveMessage := False;
  TreeView1.Selected := FNode;
  // get mailheader again
  MailOptionsForm.SaveMailHeader;
  // add listview item
  Item := ListView1.Items.Add;
  Item.ImageIndex := -1;
  Item.SubItems.Add(CurrentEMail.Subject);
  if OutBox then begin
    Item.SubItems.Add(GetCommataStringReceiver);
  end else
    Item.SubItems.Add(CurrentEMail.From);
  Item.SubItems.Add(DateToStr(CurrentEMail.ADate));
  Item.SubItems.Add(TimeToStr(CurrentEMail.ATime));
  Item.SubItems.Add(S);  // invisible
  // clear message display
  ListView2.Items.Clear;
  RichEdit1.Lines.Clear;
  //New text
  SL := TStringList.Create;
  NL := TStringList.Create;
  if NewText <> nil then SL.Assign(NewText);
  E := 0;
  //Signature
  if Signat then begin
    if FileExists(PAccountData(Node.Data)^.Path+'signat.txt') then begin
      NL.LoadFromFile(PAccountData(Node.Data)^.Path+'signat.txt');
      for I := 0 to SL.Count-1 do
        E := E + Length(SL.Strings[I]) + 2;
      SL.Add('');
      SL.Add('');
      for I := 0 to NL.Count-1 do
        SL.Add(NL.Strings[I]);
    end;
  end;
  SL.SaveToFile(sTempMessageFile);
  SL.Free;
  NL.Free;
  // create message file
  ActualMailFile := S;
  CurrentEMail.CompileMsgFileOnDisk(ActualMailFile);
  SaveMessage := False;
  // set actual item
  ListView1.Selected := Item;
  Item := ListView1.GetItemAt(2, 20);
  // Logo
  if Assigned(Item) then begin
    P := ListView1.Selected.GetPosition;
    Y := P.Y;
    P := Item.GetPosition;
    ListView1.Scroll(0, -(P.Y - Y));
  end;
  // Logo
  SaveMessage := False;
  UpdateListView;
  SaveMessage := False;
  RichEdit1.SetFocus;
  RichEdit1.SelStart := E;
  Screen.Cursor := crDefault;
  Result := True;
end;

procedure TMainForm.New3Click(Sender: TObject);
begin
  NewMessage2.Enabled := False;
  if MailOptionsForm.Visible = False then
    NewMessage(True, True, '', '', '', nil);
  NewMessage2.Enabled := True;
end;

procedure TMainForm.Replay1Click(Sender: TObject);
var
  S, T: String;
  K: Integer;
begin
  if (ListView1.SelCount <> 1) or (ListView1.Selected = nil) then Exit;
  S := '';
  for K := 0 to CurrentEMail.Fields.Count-1 do
    if LowerCase(CurrentEMail.Fields.Strings[K]) = 'reply-to' then begin
      S := CurrentEMail.FieldValues.Strings[K];
      Break;
    end;
  if ExtractEMailAddress(S) = '' then S := CurrentEMail.From;
  if Pos(UpperCase(ListBox1.Items[15]), UpperCase(CurrentEMail.Subject)) <> 1 then
    T := ListBox1.Items[15]+' '+CurrentEMail.Subject else T := CurrentEMail.Subject;
  NewMessage(False, True, T, S, '', nil);
end;

procedure TMainForm.ReplayQuoted1Click(Sender: TObject);
var
  S, T, U: String;
  SL: TStringList;
  I, K: Integer;
begin
  if (ListView1.SelCount <> 1) or (ListView1.Selected = nil) then Exit;
  SL := TStringList.Create;
  for I := 0 to RichEdit1.Lines.Count-1 do
    SL.Add(SoftLineBreak(RichEdit1.Lines[I], True));
  S := '';
  for K := 0 to CurrentEMail.Fields.Count-1 do
    if LowerCase(CurrentEMail.Fields.Strings[K]) = 'reply-to' then begin
      S := CurrentEMail.FieldValues.Strings[K];
      Break;
    end;
  if ExtractEMailAddress(S) = '' then S := CurrentEMail.From;
  SL.Insert(0, '');
  U := DateToStr(CurrentEMail.ADate)+' '+TimeToStr(CurrentEMail.ATime);
  if SkipSpacesAtEnd(ExtractEMailName(CurrentEMail.From)) = '' then
    T := Format(ListBox1.Items[16], [U])
  else
    T := Format(ListBox1.Items[17], [SkipSpacesAtEnd(ExtractEMailName(CurrentEMail.From)), U]);
  SL.Insert(0, T);
  SL.Add('');
  if Pos(UpperCase(ListBox1.Items[15]), UpperCase(CurrentEMail.Subject)) <> 1 then
    T := ListBox1.Items[15]+' '+CurrentEMail.Subject else T := CurrentEMail.Subject;
  NewMessage(False, True, T, S, '', SL);
  SL.Free;
end;

procedure TMainForm.PopupMenu4Popup(Sender: TObject);
begin
  if RichEdit1.Enabled = False then begin
    Cut1.Enabled := False;
    Copy1.Enabled := False;
    Delete5.Enabled := False;
    Cut2.Enabled := False;
    Copy2.Enabled := False;
    Delete6.Enabled := False;
    SelectAll1.Enabled := False;
    SelectAll2.Enabled := False;
    Paste1.Enabled := False;
    Paste2.Enabled := False;
    Exit;
  end;
  if RichEdit1.SelLength > 0 then begin
    Cut1.Enabled := True;
    Copy1.Enabled := True;
    Delete5.Enabled := True;
    Cut2.Enabled := True;
    Copy2.Enabled := True;
    Delete6.Enabled := True;
  end else begin
    Cut1.Enabled := False;
    Copy1.Enabled := False;
    Delete5.Enabled := False;
    Cut2.Enabled := False;
    Copy2.Enabled := False;
    Delete6.Enabled := False;
  end;
  if (RichEdit1.Lines.Count = 1) and (Length(RichEdit1.Lines[0]) > 0) then begin
    SelectAll1.Enabled := True;
    SelectAll2.Enabled := True;
  end else begin
    SelectAll1.Enabled := False;
    SelectAll2.Enabled := False;
  end;
  if RichEdit1.Lines.Count > 1 then begin
    SelectAll1.Enabled := True;
    SelectAll2.Enabled := True;
  end;
  Paste1.Enabled := False;
  Paste2.Enabled := False;
  if ClipBoard.HasFormat(CF_TEXT) then
    if ClipBoard.AsText <> '' then begin
      Paste1.Enabled := True;
      Paste2.Enabled := True;
    end;
end;

procedure TMainForm.Delete5Click(Sender: TObject);
begin
  RichEdit1.ClearSelection;
end;

procedure TMainForm.Copy1Click(Sender: TObject);
begin
  RichEdit1.CopyToClipboard;
end;

procedure TMainForm.Paste1Click(Sender: TObject);
begin
  RichEdit1.PasteFromClipboard;
end;

procedure TMainForm.Cut1Click(Sender: TObject);
begin
  RichEdit1.CutToClipboard;
end;

procedure TMainForm.SelectAll1Click(Sender: TObject);
begin
  RichEdit1.SelectAll;
end;

procedure TMainForm.SendMails1Click(Sender: TObject);
begin
  OnlineSession(2);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if SaveMessage then DoSaveMessage;
end;

procedure TMainForm.ListView2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Ord(Key) = 46 then Delete3Click(Self);
end;

procedure TMainForm.GoOnline1Click(Sender: TObject);
begin
  OnlineSession(3);
end;

procedure TMainForm.EnvironmentOptions1Click(Sender: TObject);
begin
  Modal1.Enabled := False;
  EnviroForm := TEnviroForm.Create(Self);
  EnviroForm.ShowModal;
  EnviroForm.Free;
  Modal1.Enabled := True;
end;

procedure TMainForm.AboutPhoenix1Click(Sender: TObject);
begin
  InfoForm := TInfoForm.Create(Self);
  InfoForm.ShowModal;
  Infoform.Free;
end;

procedure TMainForm.TipoftheDay1Click(Sender: TObject);
begin
  TipsForm := TTipsForm.Create(Self);
  TipsForm.ShowModal;
  TipsForm.Free;
end;

procedure TMainForm.SetAccountMenusEnabled(OnlyFalse: Boolean);
begin
  ActualizeStatusBar;
  if (GetActualAccount = nil) or (AreWeOnline) then begin
    FetchSendMails1.Enabled := False;
    GoOnline1.Enabled := False;
    SendMail1.Enabled := False;
    FetchMails1.Enabled := False;
    SpeedButton4.Enabled := False;
    SpeedButton5.Enabled := False;
    SpeedButton6.Enabled := False;
    FetchMail1.Enabled := False;
    SendMail2.Enabled := False;
  end;
  if GetActualAccount = nil then begin
    Edit1.Enabled := False;
    Folder1.Enabled := False;
    DeleteAccount1.Enabled := False;
    Delete2.Enabled := False;
    New3.Enabled := False;
    NewMessage1.Enabled := False;
    SpeedButton3.Enabled := False;
  end else begin
    if OnlyFalse then Exit;
    Delete2.Enabled := True;
    Edit1.Enabled := True;
    Folder1.Enabled := True;
    DeleteAccount1.Enabled := True;
    SpeedButton3.Enabled := True;
    if AreWeOnline = False then begin
      SpeedButton4.Enabled := True;
      SpeedButton5.Enabled := True;
      SpeedButton6.Enabled := True;
      GoOnline1.Enabled := True;
      FetchMail1.Enabled := True;
      SendMail2.Enabled := True;
      SendMail1.Enabled := True;
      FetchMails1.Enabled := True;
      FetchSendMails1.Enabled := True;
    end;
    New3.Enabled := True;
    NewMessage1.Enabled := True;
  end;
end;

procedure TMainForm.SetMessageMenusEnabled;
begin
  if ListView1.Selected = nil then begin
    SpeedButton9.Enabled := False;
    Delete4.Enabled := False;
    ToggleUnreadFlag1.Enabled := False;
    DeleteMessage1.Enabled := False;
    ToggleReadUnreadFlag1.Enabled := False;
    AddtoAdressbook1.Enabled := False;
    AddtoAdressbook2.Enabled := False;
    SpeedButton13.Enabled := False;
  end else begin
    SpeedButton9.Enabled := True;
    Delete4.Enabled := True;
    ToggleUnreadFlag1.Enabled := True;
    DeleteMessage1.Enabled := True;
    ToggleReadUnreadFlag1.Enabled := True;
    AddtoAdressbook1.Enabled := True;
    AddtoAdressbook2.Enabled := True;
    SpeedButton13.Enabled := True;
  end;
  if ListView1.Items.Count > 0 then begin
    SelectAllMessages1.Enabled := True;
    SelectAllMessages2.Enabled := True;
    SearchMessage1.Enabled := True;
    SpeedButton15.Enabled := True;
  end else begin
    SelectAllMessages1.Enabled := False;
    SelectAllMessages2.Enabled := False;
    SearchMessage1.Enabled := False;
    SpeedButton15.Enabled := False;
  end;
  if (ListView1.SelCount = 1) and (ListView1.Selected <> nil) then begin
    if GetActualAccount <> nil then begin
      SpeedButton2.Enabled := True;
      Replay1.Enabled := True;
      ReplayQuoted1.Enabled := True;
      Replay2.Enabled := True;
      ReplayQuoted2.Enabled := True;
      SpellCheck1.Enabled := True;
      SpeedButton10.Enabled := True;
      Forward1.Enabled := True;
      SpeedButton14.Enabled := True;
      Redirect1.Enabled := True;
      SpeedButton16.Enabled := True;
      Forward2.Enabled := True;
      Redirect2.Enabled := True;
      ASpeedButton1.Enabled := True;
      SpeedButton11.Enabled := True;
    end;
    if XPrint1.PrinterAvailable then begin
      Print1.Enabled := True;
      SpeedButton17.Enabled := True;
    end;
    Properties4.Enabled := True;
    Properties5.Enabled := True;
    AddFile1.Enabled := True;
    Add1.Enabled := True;
  end else begin
    SpeedButton2.Enabled := False;
    Properties4.Enabled := False;
    Replay1.Enabled := False;
    ReplayQuoted1.Enabled := False;
    Forward1.Enabled := False;
    SpeedButton14.Enabled := False;
    Redirect1.Enabled := False;
    SpeedButton16.Enabled := False;
    SpellCheck1.Enabled := False;
    Forward2.Enabled := False;
    Redirect2.Enabled := False;
    SpeedButton10.Enabled := False;
    Properties5.Enabled := False;
    Replay2.Enabled := False;
    ReplayQuoted2.Enabled := False;
    Print1.Enabled := False;
    SpeedButton17.Enabled := False;
    AddFile1.Enabled := False;
    Add1.Enabled := False;
    ASpeedButton1.Enabled := False;
    SpeedButton11.Enabled := False;
  end;
  if (ListView1.SelCount = 1) and (ListView1.Selected <> nil) and (ListView2.SelCount = 1) then begin
    SaveAs2.Enabled := True;
    SaveAs3.Enabled := True;
  end else begin
    SaveAs2.Enabled := False;
    SaveAs3.Enabled := False;
  end;
  if (ListView1.SelCount = 1) and (ListView1.Selected <> nil) and (ListView2.SelCount > 0) then begin
    Open2.Enabled := True;
    Save1.Enabled := True;
    DeleteFile1.Enabled := True;
    Open1.Enabled := True;
    QuickView1.Enabled := True;
    QuickView2.Enabled := True;
    Saveas1.Enabled := True;
    Delete3.Enabled := True;
  end else begin
    Open2.Enabled := False;
    Save1.Enabled := False;
    DeleteFile1.Enabled := False;
    Open1.Enabled := False;
    QuickView1.Enabled := False;
    QuickView2.Enabled := False;
    Saveas1.Enabled := False;
    Delete3.Enabled := False;
  end;
  if AreWeOnline then begin
    CancelOnlineOperation1.Enabled := True;
    SpeedButton12.Enabled := True;
  end else begin
    CancelOnlineOperation1.Enabled := False;
    SpeedButton12.Enabled := False;
  end;
  SetAccountMenusEnabled(True);
end;

procedure TMainForm.ListView1Change(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
  if csDestroying in ComponentState then Exit;
  SetMessageMenusEnabled;
end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
var
  P: TPoint;
begin
  P := SpeedButton2.ClientToScreen(Point(0, SpeedButton2.Height));
  if SpeedButton2.Enabled then PopUpMenu5.Popup(P.X, P.Y);
end;

procedure TMainForm.SpeedButton7Click(Sender: TObject);
begin
  ShowPhoenixMail1Click(Self);
  AddressBook2.Enabled := False;
  if AddressForm.ShowModal = mrOK then begin
    NewMessage(True, True, '', AddressForm.GetSelAddresses, '', nil);
  end;
  AddressBook2.Enabled := True;
end;

procedure TMainForm.Print1Click(Sender: TObject);
var
  I, E, CurPixel: Integer;
  R: TRect;
  D, T: TDateTime;
begin
  if ListView1.Selected = nil then Exit;
  if XPrint1.PrinterAvailable = False then begin
    MessageDlg(ListBox1.Items[18], mtError, [mbOk], 0);
    Exit;
  end;
  if XPrint1.Printing then begin
    MessageDlg(ListBox1.Items[19], mtError, [mbOk], 0);
    Exit;
  end;
  if PrintDialog1.Execute = False then begin
    Exit;
  end;
  XPrint1.BeginDoc;
  with XPrint1.Canvas do begin
    // Header bold font
    Font.Name := 'Arial';
    Font.Pitch := fpDefault;
    Font.Style := [fsBold];
    XPrint1.SetFontSize(10);
    I := TextHeight('Test gYpQMHJ') div 2; // Linespace
    E := TextWidth('Subject:Mh');           // Longest Width
    TextOut(200, I*3, ListBox1.Items[20]);
    TextOut(200, I*5, ListBox1.Items[21]);
    TextOut(200, I*7, ListBox1.Items[22]);
    TextOut(200, I*9, ListBox1.Items[23]);
    // Header fields normal font
    Font.Name := 'Arial';
    Font.Pitch := fpDefault;
    Font.Style := [];
    D := Date;
    T := Time;
    TextOut(200, 0, 'Phoenix Mail  '+DateToStr(D)+'  '+TimeToStr(T));
    R := Bounds(0, 0, XPrint1.PrintWidth, XPrint1.PrintHeight);
    DrawText(Handle, PChar(ListBox1.Items[24]+' '+IntToStr(XPrint1.PageNumber)+' '), -1, R, DT_RIGHT);
    TextOut(E, I*3, CurrentEMail.Subject);
    TextOut(E, I*5, CurrentEMail.From);
    TextOut(E, I*7, StringListToCommataString(CurrentEMail.ToReceiver, False));
    TextOut(E, I*9, DateToStr(CurrentEMail.ADate)+'  '+TimeToStr(CurrentEMail.ATime));
    // Border
    MoveTo(0, I*2);
    LineTo(XPrint1.PrintWidth, I*2);
    MoveTo(0, 0);
    LineTo(XPrint1.PrintWidth, 0);
    LineTo(XPrint1.PrintWidth, I*12);
    LineTo(0, I*12);
    LineTo(0,0);
    CurPixel := I*15;
    // RichEditText
    for E := 0 to RichEdit1.Lines.Count-1 do begin
      R := Bounds(0, CurPixel, XPrint1.PrintWidth, XPrint1.PrintHeight);
      CurPixel := CurPixel+DrawText(Handle, PChar(RichEdit1.Lines[E]), -1, R, DT_CALCRECT or DT_LEFT or DT_WORDBREAK);
      if RichEdit1.Lines[E] = '' then CurPixel := Curpixel+I*2; // Empty line?
      if CurPixel >= XPrint1.PrintHeight then begin
        // New Page
        XPrint1.NewPage;
        TextOut(200, 0, 'Phoenix Mail  '+DateToStr(Date)+'  '+TimeToStr(Time));
        R := Bounds(0, 0, XPrint1.PrintWidth, XPrint1.PrintHeight);
        DrawText(Handle, PChar(ListBox1.Items[24]+' '+IntToStr(XPrint1.PageNumber)+' '), -1, R, DT_RIGHT);
        MoveTo(0, 0);
        LineTo(XPrint1.PrintWidth, 0);
        LineTo(XPrint1.PrintWidth, I*2);
        LineTo(0, I*2);
        LineTo(0,0);
        CurPixel := I*5;
        R := Bounds(0, CurPixel, XPrint1.PrintWidth, XPrint1.PrintHeight);
      end;
      DrawText(Handle, PChar(RichEdit1.Lines[E]), -1, R, DT_LEFT or DT_WORDBREAK);
    end;
    // Have a nice day
    if bFriendlyPrinter then begin
      MoveTo(0, CurPixel+I*3);
      LineTo(XPrint1.PrintWidth, CurPixel+I*3);
      TextOut(0, CurPixel+I*4, ListBox1.Items[25]);
    end;
  end;
  XPrint1.EndDoc;
end;

procedure TMainForm.PrinterSetup1Click(Sender: TObject);
begin
  if XPrint1.PrinterAvailable = False then begin
    MessageDlg(ListBox1.Items[18], mtError, [mbOk], 0);
    Exit;
  end;
  PrinterSetupDialog1.Execute;
end;

procedure TMainForm.ActualizeStatusBar;
var
  Node: TTreeNode;
  I, E: Integer;
begin
  Node := GetActualAccount;
  if Node = nil then
    StatusBar1.Panels[0].Text := ListBox1.Items[26]
  else
    StatusBar1.Panels[0].Text := GetPXTreeNodeName(Node);//Format(ListBox1.Items[27], [Node.Text]);
  E := 0;
  for I := 0 to ListView1.Items.Count-1 do
    if ListView1.Items[I].ImageIndex <> -1 then Inc(E);
  StatusBar1.Panels[1].Text := Format(ListBox1.Items[28], [IntToStr(E), IntToStr(ListView1.Items.Count)]);
  //StatusBar1.Panels[2].Text := Format(ListBox1.Items[29], [IntToStr(ListView2.Items.Count)]);
end;

procedure TMainForm.Image1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar(sHomepage), '', '', SW_SHOWNORMAL);
end;

procedure TMainForm.Signature1Click(Sender: TObject);
var
  G: Integer;
begin
  SignatureForm := TSignatureForm.Create(Self);
  if (ListView1.SelCount = 1) and (ListView1.Selected <> nil) then begin
    SignatureForm.CanAttach := True;
  end else begin
    SignatureForm.Button4.Visible := False;
    SignatureForm.Button3.Default := True;
    SignatureForm.CanAttach := False;
  end;
  if SignatureForm.ShowModal = mrOK then begin
    for G := 0 to SignatureForm.Memo1.Lines.Count-1 do
      RichEdit1.Lines.Add(SignatureForm.Memo1.Lines[G]);
  end;
  SignatureForm.Free;
end;

procedure TMainForm.Forward1Click(Sender: TObject);
var
  SL: TStringList;
  T: String;
begin
  if (ListView1.SelCount <> 1) or (ListView1.Selected = nil) then Exit;
  SL := TStringList.Create;
  SL.Assign(RichEdit1.Lines);
  SL.Insert(0, '>'+ListBox1.Items[30]);
  SL.Insert(1, '>');
  SL.Insert(2, '>'+ListBox1.Items[21]+' '+CurrentEMail.From);
  SL.Insert(3, '>'+ListBox1.Items[22]+' '+StringListToCommataString(CurrentEMail.ToReceiver, False));
  SL.Insert(4, '>'+ListBox1.Items[23]+' '+DateToStr(CurrentEMail.ADate)+'  '+TimeToStr(CurrentEMail.ATime));
  SL.Insert(5, '>'+ListBox1.Items[20]+' '+CurrentEMail.Subject);
  SL.Insert(6, '');
  BackupAttachments;
  if Pos(UpperCase(ListBox1.Items[31]), UpperCase(CurrentEMail.Subject)) <> 1 then
    T := ListBox1.Items[31]+' '+CurrentEMail.Subject else T := CurrentEMail.Subject;
  if NewMessage(True, False, T, '', CurrentEMail.From, SL) then begin
    RestoreAttachments;
  end;
  SL.Free;
end;

procedure TMainForm.Redirect1Click(Sender: TObject);
var
  SL: TStringList;
  T: String;
begin
  if (ListView1.SelCount <> 1) or (ListView1.Selected = nil) then Exit;
  SL := TStringList.Create;
  SL.Assign(RichEdit1.Lines);
  SL.Insert(0, '>'+ListBox1.Items[32]);
  SL.Insert(1, '>');
  SL.Insert(2, '>'+ListBox1.Items[21]+' '+CurrentEMail.From);
  SL.Insert(3, '>'+ListBox1.Items[22]+' '+StringListToCommataString(CurrentEMail.ToReceiver, False));
  SL.Insert(4, '>'+ListBox1.Items[23]+' '+DateToStr(CurrentEMail.ADate)+'  '+TimeToStr(CurrentEMail.ATime));
  SL.Insert(5, '>'+ListBox1.Items[20]+' '+CurrentEMail.Subject);
  SL.Insert(6, '');
  BackupAttachments;
  if Pos(UpperCase(ListBox1.Items[33]), UpperCase(CurrentEMail.Subject)) <> 1 then
    T := ListBox1.Items[33]+' '+CurrentEMail.Subject else T := CurrentEMail.Subject;
  if NewMessage(False, False, T, CurrentEMail.From, '', SL) then begin
    RestoreAttachments;
  end;
  SL.Free;
end;

procedure TMainForm.ListView1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if csDestroying in ComponentState then Exit;
  if ListView1.SelCount = 1 then
    if ListView1.Selected <> nil then
      if ListView1.Selected.SubItems[4] = ActualMailFile then
        Exit;
  UpdateListView;
  ActualizeStatusBar;
end;

procedure TMainForm.BackupAttachments;
var
  I: Integer;
  A, B: array[0..MAX_PATH-1] of Char;
  S: String;
begin
  BKAttachments1.Clear;
  BKAttachments2.Clear;
  for I := 0 to ListView2.Items.Count-1 do begin
    BKAttachments1.Add(sTemporaryFolder+ListView2.Items[I].Caption);
    GetTempPath(MAX_PATH, @A);
    GetTempFileName(@A, 'PXA', 0, @B);
    S := B;
    BKAttachments2.Add(S);
    SetFileAttr(BKAttachments1.Strings[I], False, True, False, False);
    CopyFile(PChar(BKAttachments1.Strings[I]), PChar(BKAttachments2.Strings[I]), False);
  end;
end;

procedure TMainForm.RestoreAttachments;
var
  I: Integer;
  Item: TListItem;
  SHFileInfo: TSHFileInfo;
begin
   for I := 0 to BKAttachments1.Count-1 do begin
    CopyFile(PChar(BKAttachments2.Strings[I]), PChar(BKAttachments1.Strings[I]), False);
    DeleteFile(PChar(BKAttachments2.Strings[I]));
    Item := ListView2.Items.Add;
    Item.Caption := ExtractFileName(BKAttachments1.Strings[I]);
    SHGetFileInfo(PChar(BKAttachments1.Strings[I]), 0, SHFileInfo, SizeOf(SHFileInfo), SHGFI_SYSICONINDEX or SHGFI_LARGEICON);
    Item.ImageIndex := SHFileInfo.iIcon;
  end;
  BKAttachments1.Clear;
  BKAttachments2.Clear;
end;

procedure TMainForm.PopupMenu2Popup(Sender: TObject);
begin
  SetMessageMenusEnabled;
end;

procedure TMainForm.ListView1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Ord(Key) = 46 then Delete4Click(Self);
  if Ord(Key) in [40,38] then ListView1MouseUp(Self, mbLeft, [ssLeft], 0, 0);
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  if csDestroying in ComponentState then Exit;
  if csLoading in ComponentState then Exit;
  //OnlineThread
  Inc(OnlineThreadCounter, Timer1.Interval);
  if OnlineThreadCounter > 1000 then OnlineThreadCounter := 0; //make sure...
  if OnlineThreadTerminated then begin
    if (OnlineThreadCounter > 400) then begin
      Timer1.Enabled := False;
      OnlineThreadTerminated := False;
      OnlineThreadCounter := 0;
      Screen.Cursor := crHourGlass;
      try
        if OnlineForm <> nil then OnlineForm.Free;
        if OnlineThread <> nil then OnlineThread.Free;
        OnlineForm := nil;
        OnlineThread := nil;
        SelectMailForm.Free;
        StrPCopy(NotifyIconData.szTip, 'Phoenix Mail');
        Shell_NotifyIcon(NIM_MODIFY, @NotifyIconData);
        PaintBox1.Visible := False;
        AreWeOnline := False;
        SetAccountMenusEnabled(False);
        SetMessageMenusEnabled;
        Label4.Caption := '';
        Label5.Caption := '';
        StatusBar1.Panels[2].Text := '';
        StatusBar1.Panels[3].Text := '';
      finally
        if bDUNNormalQuit then DialUp1.GoOffline;
        Screen.Cursor := crDefault;
        ReadyToClose := True;
        Timer1.Enabled := True;
      end;
    end;
  end;
  // Read/Unread Flag
  if (ListView1.SelCount = 1) and (ListView1.Selected <> nil) and (ListView1.Selected.ImageIndex <> -1) then begin
    Inc(ReadCounter, Timer1.Interval);
    if ReadCounter > (iMarkAsReadSec*1000) then begin
      ReadCounter := 0;
      if ListView1.Selected.ImageIndex <> -1 then ToggleUnreadFlag1Click(Self);
    end;
  end;
  //Animation
  if AreWeOnline then begin
    if Label4.Caption <> '' then begin
      PaintBox1.Visible := False;
      Exit;
    end;
    if not bHideAnimations then begin
      PaintBox1.Visible := True;
      if (AnimationPosition > (PaintBox1.Width-AniBmp1.Width-3)) and (AnimationToLeft = True) then begin
        AnimationPosition := PaintBox1.Width-3;
        AnimationToLeft := False;
        PaintBox1.Canvas.Brush.Color := clBtnFace;
        PaintBox1.Canvas.FillRect(Rect(0, 0, PaintBox1.Width, PaintBox1.Height));
      end;
      if (AnimationPosition < 0) and (AnimationToLeft = False)  then begin
        AnimationPosition := -AniBmp1.Width+3;
        AnimationToLeft := True;
        PaintBox1.Canvas.Brush.Color := clBtnFace;
        PaintBox1.Canvas.FillRect(Rect(0, 0, PaintBox1.Width, PaintBox1.Height));
      end;
      if AnimationToLeft then begin
        Inc(AnimationPosition, 3);
        PaintBox1.Canvas.Draw(AnimationPosition, 0, AniBmp2);
      end else begin
        Dec(AnimationPosition, 3);
        PaintBox1.Canvas.Draw(AnimationPosition, 0, AniBmp1);
      end;
    end;
  end;
  // Active connection
  //S := GetActiveConnection;
  //if S = '' then S := ListBox1.Items[34] else S := Format(ListBox1.Items[35], [S]);
  //if Statusbar1.Panels[3].Text <> S then Statusbar1.Panels[3].Text := S;
end;

procedure TMainForm.ListView1DrawHeader(Control: TWinControl; var ACanvas: TCanvas; Index: Integer; var ARect: TRect; Selected: Boolean; var DefaultDrawing: Boolean);
begin
  if Index = 0 then begin
    DefaultDrawing := False;
    ACanvas.BrushCopy(Rect(ARect.Left+2, ARect.Top, ARect.Left+18, ARect.Top+16), Image2.Picture.Bitmap, Rect(0, 0, 16, 16), clFuchsia);
  end else
    DefaultDrawing := True;
end;

{procedure TMainForm.WMDrawItem(var Msg: TWMDrawItem);
var
  MenuItem: TMenuItem;
  ACanvas: TCanvas;
  ARect: TRect;
  Selected: Boolean;
begin
  with Msg.DrawItemStruct^ do begin
    if ctlType = ODT_MENU then begin
      MenuItem := PopupMenu6.FindItem(ItemID, fkCommand);
      if MenuItem <> nil then
        DrawPopUpMenuItem(MenuItem, hDC, rcItem, (ItemState = ODS_SELECTED));
    end;
  end;
end;

procedure TMainForm.WMMeasureItem(var Msg: TWMMeasureItem);
begin

end;

procedure TMainForm.DrawPopUpMenuItem(Item: TMenuItem; DC: HDC; ARect: TRect; Selected: Boolean);
begin

end;}

procedure TMainForm.MenuItem3DrawIteehm(Sender: TObject; ACanvas: TCanvas;
  ARect: TRect; Selected: Boolean);
var
  S: String;
  Y: Integer;
  R: TRect;
begin
  ARect.Left := ARect.Left+27;
  ACanvas.Font.Name := 'MS Sans Serif';
  ACanvas.Font.Size := 8;
  ACanvas.Font.Style := [];
  S := TMenuItem(Sender).Caption;
  if TMenuItem(Sender).Default then ACanvas.Font.Style := [fsBold];
  if S = '-' then S := '';

  if Length(S) > 0 then begin
    ACanvas.TextRect(ARect, ARect.Left+16, ARect.Top+1, S);
    Y := ARect.Top + 13;
    ACAnvas.Pen.Color := ACanvas.Font.Color;
    ACanvas.MoveTo(ARect.Left + 16, Y);
    ACanvas.LineTo(ARect.Left + 16 + ACanvas.TextWidth(S[1]), Y);
  end else begin
    ACAnvas.Pen.Color := clBtnShadow;
    ACanvas.MoveTo(ARect.Left, ARect.Top+4);
    ACanvas.LineTo(ARect.Right, ARect.Top+4);
    ACAnvas.Pen.Color := clBtnHighLight;
    ACanvas.MoveTo(ARect.Left, ARect.Top+5);
    ACanvas.LineTo(ARect.Right, ARect.Top+5);
  end;
  ACAnvas.Pen.Color := clBtnShadow;
  ACanvas.MoveTo(ARect.Left-3, ARect.Top);
  ACanvas.LineTo(ARect.Left-3, ARect.Bottom);
  ACAnvas.Pen.Color := clBtnHighLight;
  ACanvas.MoveTo(ARect.Left-2, ARect.Top);
  ACanvas.LineTo(ARect.Left-2, ARect.Bottom);
  Y := ARect.Top;
  R := Rect(0, Y, 22, Y+ARect.Bottom-ARect.Top);
  ACanvas.CopyRect(Rect(0, ARect.Top, 22, ARect.Bottom), Image3.Canvas, R);
end;

procedure TMainForm.MenuItem3MeasureItem(Sender: TObject; ACanvas: TCanvas; var Width, Height: Integer);
begin
  Height := 17;
  Width := ACanvas.TextWidth(TMenuItem(Sender).Caption)+44;
  if TMenuItem(Sender).Caption = '-' then Height := 10;
end;

procedure TMainForm.AppMinimize(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE);
  Visible := False;
end;

procedure TMainForm.WMTaskIcon(var Message: TMessage);
var
  P: TPoint;
begin
  case Message.lParam of
    WM_LBUTTONDBLCLK: begin
    end;
    WM_LBUTTONUP: begin
      ShowPhoenixMail1Click(Self);
    end;
    WM_RBUTTONUP: begin
      GetCursorPos(P);
      PopUpMenu6.PopUp(P.X, P.Y);
    end;
  end;
end;

procedure TMainForm.WMSysCommand(var Message: TMessage);
begin
  if (Message.WParam = SC_MINIMIZE) then begin
    ShowWindow(Application.Handle, SW_HIDE);
    Visible := False;
  end else inherited;
end;

procedure TMainForm.ShowPhoenixMail1Click(Sender: TObject);
begin
  Visible := True;
  ShowWindow(Application.Handle, SW_RESTORE);
  SetForegroundWindow(Application.Handle);
  SetForegroundWindow(Handle);
  if OnlineForm <> nil then try SetForegroundWindow(OnlineForm.Handle); except end;
end;

procedure TMainForm.Modal1Click(Sender: TObject);
begin
  ShowPhoenixMail1Click(Self);
  Modal1.Enabled := False;
  EnviroForm := TEnviroForm.Create(Self);
  EnviroForm.PageControl1.ActivePage := EnviroForm.TabSheet4;
  EnviroForm.ShowModal;
  EnviroForm.Free;
  Modal1.Enabled := True;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if AreWeOnline then begin
    if SpeedButton12.Enabled = False then Exit;
    if MessageDlg(ListBox1.Items[90], mtWarning, [mbYes, mbNo], 0) = mrYes then begin
      Terminating := True;
      OnlineThread.ShowError(MainForm.ListBox1.Items[82]);
      repeat Application.HandleMessage; until ReadyToClose;
      CanClose := True;
    end else
      CanClose := False;
  end else begin
    Terminating := True;
    CanClose := True;
  end;
end;

procedure TMainForm.OnlineSession(OnlineTyp: Byte);
var
  Node: TTreeNode;
  I, ToSendCount: Integer;

  function GetSubNotes(Node: TTreeNode; var SL: TStringList): Integer;
  var
    SearchRec: TSearchRec;
    I, Found: Integer;
  begin
    Result := 0;
    for I := 0 to Node.Count-1 do begin
      if PFolderData(Node.Item[I].Data)^.OutBox then begin
        Found := FindFirst(PFolderData(Node.Item[I].Data)^.Path+'*.msg', faAnyFile, SearchRec);
        while Found = 0 do begin
          SL.Add(PFolderData(Node.Item[I].Data)^.Path+SearchRec.Name);
          Inc(Result);
          Found := FindNext(SearchRec);
        end;
        FindClose(SearchRec);
      end;
      if Node.Count > 0 then GetSubNotes(Node.Item[I], SL);
    end;
  end;

  procedure AddAccountData(Node: TTreeNode);
  var
    SL: TStringList;
    I: Integer;
  begin
    if (OnlineTyp in [2, 3]) and (PAccountData(Node.Data)^.DoSMTP = 1) then begin
      SL := TStringList.Create;
      GetSubNotes(Node, SL);
      ToSendCount := SL.Count;
      if SL.Count > 0 then begin
        OnlineForm.CommandList.Add('SMTP');
        OnlineForm.CommandList.Add(PAccountData(Node.Data)^.Name);
        OnlineForm.CommandList.Add(PAccountData(Node.Data)^.SMTPServer);
        OnlineForm.CommandList.Add(PAccountData(Node.Data)^.SMTPPort);
        OnlineForm.CommandList.Add('');
        OnlineForm.CommandList.Add('');
        OnlineForm.CommandList.Add('<'+ExtractEMailAddress(PAccountData(Node.Data)^.FromMail)+'>');
        OnlineForm.CommandList.Add('');
        OnlineForm.CommandList.Add('');
        OnlineForm.CommandList.Add('');
        OnlineForm.CommandList.Add(PAccountData(Node.Data)^.Path);
        OnlineForm.CommandList.Add(IntToStr(Integer(@Node)));
        OnlineForm.CommandList.Add(IntToStr(SL.Count));
        for I := 0 to SL.Count-1 do OnlineForm.CommandList.Add(SL.Strings[I]);
      end;
      SL.Free;
    end;
    if (OnlineTyp in [1, 3]) and (PAccountData(Node.Data)^.DoPOP = 1) then begin
      OnlineForm.CommandList.Add('POP3');
      OnlineForm.CommandList.Add(PAccountData(Node.Data)^.Name);
      OnlineForm.CommandList.Add(PAccountData(Node.Data)^.POPServer);
      OnlineForm.CommandList.Add(PAccountData(Node.Data)^.POPPort);
      OnlineForm.CommandList.Add(PAccountData(Node.Data)^.POPUser);
      if PAccountData(Node.Data)^.PromptPassword = 1 then OnlineForm.CommandList.Add('')
        else OnlineForm.CommandList.Add(PAccountData(Node.Data)^.POPPass);
      OnlineForm.CommandList.Add('');
      OnlineForm.CommandList.Add(IntToStr(PAccountData(Node.Data)^.StandardDownload));
      OnlineForm.CommandList.Add(PAccountData(Node.Data)^.DeleteFilter);
      OnlineForm.CommandList.Add(PAccountData(Node.Data)^.KeepFilter);
      OnlineForm.CommandList.Add(PAccountData(Node.Data)^.Path);
      OnlineForm.CommandList.Add(IntToStr(Integer(@Node)));
    end;
  end;

begin
  if AreWeOnline then Exit;
  FetchedMailCount := 0;
  SendMailCount := 0;
  AvailableMailCount := 0;
  ToSendCount := 0;
  Node := GetActualAccount;
  if Assigned(Node) = False then Exit;
  if Assigned(Node.Data) = False then Exit;
  if OnlineTyp <> 4 then begin
    ListView1.Selected := nil;
    UpdateListView;
    ActualizeStatusBar;
  end;
  Screen.Cursor := crHourGlass;
  StrPCopy(NotifyIconData.szTip, 'Phoenix Mail - '+ListBox1.Items[36]);
  Shell_NotifyIcon(NIM_MODIFY, @NotifyIconData);
  AreWeOnline := True;
  ReadyToClose := False;
  Abort := False;
  SetMessageMenusEnabled;
  AnimationToLeft := True;
  AnimationPosition := -AniBmp1.Width+3;
  if not bHideAnimations then PaintBox1.Visible := True;
  OnlineForm := TOnlineForm.Create(Self);
  OnlineForm.OnlineTyp := OnlineTyp;
  if OnlineTyp in [1, 2] then AddAccountData(Node);
  if OnlineTyp in [3, 4] then begin
    for I := 0 to TreeView1.Items.Count-1 do
      if TreeView1.Items[I].StateIndex = 1 then AddAccountData(TreeView1.Items[I]);
  end;
  SelectMailForm := TSelectMailForm.Create(Self);
  if (OnlineTyp = 2) and (ToSendCount = 0) then begin
    try OnlineForm.ShowStatusMessage; except end;
    Exit;
  end;
  OnlineThread := TOnlineThread.Create;
  OnlineThread.CommandCount := OnlineForm.CommandList.Count;
  OnlineForm.DialUpNetwork;
  if Abort then Exit;
  OnlineThread.Resume;
end;

procedure TMainForm.DragDropWndProc(var Message: TMessage);
begin
   with Message do begin
     if Msg = WM_DROPFILES then
       DragDropFiles(HDrop(wParam))
     else
       Result := CallWindowProc(DragDropDefWndProc, ListView2.Handle, Msg, WParam, LParam);
   end;
end;

procedure TMainForm.DragDropFiles(hDropHandle: HDrop);
var
  PFilename: PChar;
  I, Count: Integer;
begin
  if (ListView1.SelCount <> 1) or (ListView1.Selected = nil) then Exit;
  GetMem(PFilename, 256);
  Count := DragQueryFile(hDropHandle, $FFFFFFFF, nil, 255);
  for I := 0 to Count-1 do begin
    DragQueryFile(hDropHandle, I, PFilename, 255);
    AddAttachment(StrPas(PFilename));
  end;
  FreeMem(PFilename, 256);
end;

procedure TMainForm.SearchMessage1Click(Sender: TObject);
begin
  SearchForm := TSearchForm.Create(Self);
  SearchForm.Method := 0;
  SearchForm.ShowModal;
  SearchForm.Free;
end;

procedure TMainForm.WndProc(var Message: TMessage);
begin
  if Message.Msg = WM_PREVINSTRUN then begin
    if Message.WParam = 1 then begin
      try
        AssignFile(TextFile, sTempNewMessageFile);
        Reset(TextFile);
        ReadLn(TextFile, sWriteNewMessage1);
        ReadLn(TextFile, sWriteNewMessage2);
        CloseFile(TextFile);
        DeleteFile(sTempNewMessageFile);
      except end;
    end;
    ShowPhoenixMail1Click(Self);
    if (MailOptionsForm.Visible = False) and (sWriteNewMessage1 <> '') then begin
      NewMessage(True, True, sWriteNewMessage2, sWriteNewMessage1, '', nil);
      sWriteNewMessage1 := '';
      sWriteNewMessage2 := '';
    end;
  end else
  if Message.Msg = WM_GETFORMHANDLES then begin
    // Get LangStrings
    DeleteFile(sTempLanguageFile);
    LangSupTagList := TStringList.Create;
    Memo1.Lines.Add('');
    SaveMemo(Memo1);  //memos have became obsolete
    SaveMemo(Memo1);
    bSmallToolbarButtons := False;     //Make Toolbar butttons...
    SetToolbarButtonOrder;             //...captions visible
    SaveFormStrings(MainForm);
    SaveFormStrings(AddressForm);
    MailOptionsForm.SpeedButton6.Caption := '';
    SaveFormStrings(MailOptionsForm);
    SignatureForm := TSignatureForm.Create(Self);
    SaveFormStrings(SignatureForm);
    SignatureForm.Free;
    AccountForm := TAccountForm.Create(Self);
    SaveFormStrings(AccountForm);
    AccountForm.Free;
    DirectoryForm := TDirectoryForm.Create(Self);
    SaveFormStrings(DirectoryForm);
    DirectoryForm.Free;
    EditAdrForm := TEditAdrForm.Create(Self);
    SaveFormStrings(EditAdrForm);
    EditAdrForm.Free;
    EnviroForm := TEnviroForm.Create(Self);
    SaveFormStrings(EnviroForm);
    EnviroForm.Free;
    FolderForm := TFolderForm.Create(Self);
    SaveFormStrings(FolderForm);
    FolderForm.Free;
    OnlineForm := TOnlineForm.Create(Self);
    SaveFormStrings(OnlineForm);
    OnlineForm.Free;
    SearchForm := TSearchForm.Create(Self);
    SaveFormStrings(SearchForm);
    SearchForm.Free;
    SelBookForm := TSelBookForm.Create(Self);
    SaveFormStrings(SelBookForm);
    SelBookForm.Free;
    SelectMailForm := TSelectMailForm.Create(Self);
    SaveFormStrings(SelectMailForm);
    SelectMailForm.Free;
    TipsForm := TTipsForm.Create(Self);
    SaveFormStrings(TipsForm);
    TipsForm.Free;
    StdMailForm := TStdMailForm.Create(Self);
    SaveFormStrings(StdMailForm);
    InfoForm := TInfoForm.Create(Self);
    SaveFormStrings(InfoForm);
    InfoForm.Free;
    StdMailForm.Free;
    LangSupTagList.Free;
  end else
    inherited WndProc(Message);
end;

procedure TMainForm.SaveAs3Click(Sender: TObject);
begin
  if ListView2.SelCount <> 1 then Exit;
  if DirectoryExists(sLastAttSaveDir) then
    SaveDialog1.InitialDir := sLastAttSaveDir
  else
    SaveDialog1.InitialDir := ExtractFileDir(Application.Exename);
  SaveDialog1.Filename := ListView2.Selected.Caption;
  if SaveDialog1.Execute then begin
    sLastAttSaveDir := MakeValidDirname(ExtractFilePath(SaveDialog1.Filename));
    SetFileAttr(sTemporaryFolder+ListView2.Selected.Caption, False, True, False, False);
    CopyFile(PChar(sTemporaryFolder+ListView2.Selected.Caption), PChar(SaveDialog1.Filename), False);
  end;
end;

procedure TMainForm.Message1Click(Sender: TObject);
begin
  SetMessageMenusEnabled;
end;

procedure TMainForm.SelectAllMessages1Click(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to ListView1.Items.Count-1 do
    ListView1.Items[I].Selected := True;
  ListView1MouseUp(Self, mbLeft, [ssLeft], 0, 0);
end;

procedure TMainForm.TreeView1Compare(Sender: TObject; Node1, Node2: TTreeNode; Data: Integer; var Compare: Integer);
begin
  Compare := AnsiStrIComp(PChar(GetPXTreeNodeName(Node1)), PChar(GetPXTreeNodeName(Node2)));
  if Node1 = AccountsNode then Compare := 0;
  if Node1 = TrashNode then Compare := 0;
  if Node1 = RepositoryNode then Compare := 0;
end;

procedure TMainForm.AddtoAdressbook1Click(Sender: TObject);
var
  I: Integer;
begin
  if ListView1.Selected = nil then Exit;
  for I := 0 to ListView1.Items.Count-1 do
    if ListView1.Items[I].Selected then begin
      if AddressForm.SetAddress(ListView1.Items[I].SubItems[1]) <> False then Exit;
  end;
end;

procedure TMainForm.Timer2Timer(Sender: TObject);
var
  B: Boolean;
  Hour1, Min1, Hour2, Min2, Sec, MSec: Word;
begin
  if csDestroying in ComponentState then Exit;
  if csLoading in ComponentState then Exit;
  //Auto Quit
  if (bDUNAutoQuit = True) and (AreWeOnline) then begin
    Inc(OnlineCounter);
    if OnlineCounter >= iDUNAutoQuitTime then begin
      OnlineThread.ShowError(Format(ListBox1.Items[81], [IntToStr(iDUNAutoQuitTime)]));
      Application.ProcessMessages;
      DialUp1.GoOffline;
    end;
  end;
  //Schedule
  Inc(MinutesSinceStart);
  if MinutesSinceStart > 30001 then MinutesSinceStart := 0;
  if MinutesSinceStart = sScheduleS1 then begin
    MinutesSinceStart := 0;
    B := True;
  end else
    B := False;
  if AreWeOnline then Exit;
  if bScheduleC5 then
    if MainForm.DialUp1.CurrentConnection = '' then Exit;
  if bScheduleC1 then
    if B then OnlineSession(4);
  if bScheduleC2 = False then Exit;
  DecodeTime(Time, Hour1, Min1, Sec, MSec);
  if bScheduleC3 then begin
    DecodeTime(StrToTime(sScheduleS2), Hour2, Min2, Sec, MSec);
    if (Hour1 = Hour2) and (Min1 = Min2) then OnlineSession(4);
  end;
  if bScheduleC4 then begin
    DecodeTime(StrToTime(sScheduleS3), Hour2, Min2, Sec, MSec);
    if (Hour1 = Hour2) and (Min1 = Min2) then OnlineSession(4);
  end;
end;

procedure TMainForm.SpellCheck1Click(Sender: TObject);
var
  P: TPoint;
begin
  if FileExists(sSpellCheckerFile) = False then Exit;
  SpellCheckForm := TSpellCheckForm.Create(Self);
  P.X := RichEdit1.Left;
  P.Y := RichEdit1.Top;
  P := Panel1.ClientToScreen(P);
  SpellCheckForm.Left := P.X+4;
  SpellCheckForm.Top := P.Y+4;
  SpellCheckForm.ShowModal;
  SpellCheckForm.Free;
end;

procedure TMainForm.QuickView1Click(Sender: TObject);
var
  I: Integer;
  A: array[0..MAX_PATH] of Char;
  S: String;
begin
  if ListView2.SelCount = 0 then Exit;
  for I := 0 to ListView2.Items.Count-1 do
    if ListView2.Items[I].Selected then begin
      GetSystemDirectory(A, MAX_PATH);
      S := A;
      S := MakeValidDirName(S)+'Viewers\Quikview.exe';
      ShellExecute(Handle, 'open', PChar(S), PChar(sTemporaryFolder+ListView2.Items[I].Caption), PChar(sTemporaryFolder), SW_SHOWNORMAL);
    end;
end;

procedure TMainForm.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
  if Panel = StatusBar1.Panels[0] then begin
    StatusBar.Canvas.TextOut(Rect.Left+19, Rect.Top+1, Panel.Text);
    StatusBar.Canvas.Draw(Rect.Left, Rect.Top, Image6.Picture.Bitmap);
  end;
  if Panel = StatusBar1.Panels[1] then begin
    StatusBar.Canvas.TextOut(Rect.Left+19, Rect.Top+1, Panel.Text);
    StatusBar.Canvas.Draw(Rect.Left+1, Rect.Top, Image7.Picture.Bitmap);
  end;
  if Panel = StatusBar1.Panels[2] then begin
    StatusBar.Canvas.TextOut(Rect.Left, Rect.Top+1, Panel.Text);
  end;
  if Panel = StatusBar1.Panels[3] then begin
    if Panel.Text <> '' then
      StatusBar.Canvas.Draw(Rect.Left+1, Rect.Top, Image9.Picture.Bitmap);
  end;
end;

procedure TMainForm.CreateGradientBitmap(StartPos: Integer; var GBitmap: TBitmap);
var
  I, Steps: Integer;
  Bitmap: TBitmap;
  R, G, B, OldR, OldG, OldB: Real;
  StartC, EndC, OldC: TColor;
begin
  Bitmap := TBitmap.Create;
  Bitmap.Width := GBitmap.Width;
  Bitmap.Height := GBitmap.Height;
  Bitmap.Canvas.Brush.Color := clBtnShadow;
  Bitmap.Canvas.FillRect(Rect(0, 0, Bitmap.Width, Bitmap.Height));
  if iColorDepth > 8 then begin
    Steps := Bitmap.Width - StartPos;
    StartC := ColorToRGB(clBtnShadow);
    EndC := ColorToRGB(clBtnFace);
    R := (GetRValue(EndC) - GetRValue(StartC)) / Steps;
    G := (GetGValue(EndC) - GetGValue(StartC)) / Steps;
    B := (GetBValue(EndC) - GetBValue(StartC)) / Steps;
    OldC := StartC;
    OldR := GetRValue(StartC);
    OldG := GetGValue(StartC);
    OldB := GetBValue(StartC);
    for I := 0 to Steps-1 do begin
      Bitmap.Canvas.Pen.Color := OldC;
      Bitmap.Canvas.Rectangle(I+StartPos, 0, I+StartPos+1, Bitmap.Height);
      OldR := OldR + R;
      OldG := OldG + G;
      OldB := OldB + B;
      if (OldR < 0) or (OldR > 255) then OldR := GetRValue(EndC);
      if (OldG < 0) or (OldG > 255) then OldG := GetGValue(EndC);
      if (OldB < 0) or (OldB > 255) then OldB := GetBValue(EndC);
      OldC := RGB(Round(OldR), Round(OldG), Round(OldB));
    end;
  end;
  GBitmap.Assign(Bitmap);
  Bitmap.Free;
end;

procedure TMainForm.Contents1Click(Sender: TObject);
begin
  Application.HelpContext(34);
end;

procedure TMainForm.DialUp1StatusEvent(Sender: TObject; MessageText: String; Error: Boolean);
begin
  if (OnlineThread <> nil) and (OnlineForm <> nil) then begin
    OnlineThread.SetStatusString(-1, MessageText, '');
    if Error then begin
      DialUp1.GoOffline;
      OnlineThread.ShowError(MessageText);
    end;
  end;
end;

procedure TMainForm.EmptyRepository1Click(Sender: TObject);
var
  SearchRec: TSearchRec;
  Found: Integer;
begin
  Screen.Cursor := crHourGlass;
  Application.ProcessMessages;
  Found := FindFirst(sRepositoryFolder+'*.*', faAnyFile, SearchRec);
  while Found = 0 do begin
    SetFileAttr(sRepositoryFolder+SearchRec.Name, False, True, False, False);
    DeleteFile(sRepositoryFolder+SearchRec.Name);
    Found := FindNext(SearchRec);
  end;
  FindClose(SearchRec);
  TreeView1Change(Self, TreeView1.Selected);
  ActualizeTrash;
  TreeView1.Invalidate;
end;

procedure TMainForm.ASpeedButton1Click(Sender: TObject);
var
  P: TPoint;
begin
  P := ASpeedButton1.ClientToScreen(Point(ASpeedButton1.Width, 0));
  if ASpeedButton1.Enabled then PopUpMenu2.Popup(P.X, P.Y);
end;

function TMainForm.GetToolbarButttonByIndex(Index: Integer; var ImageIndex: Integer): TSpeedButtonEx;
begin
  Result := nil;
  ImageIndex := 26;
  case Index of
    1: begin Result := SpeedButton4; ImageIndex := 0; end;
    2: begin Result := SpeedButton5; ImageIndex := 2; end;
    3: begin Result := SpeedButton6; ImageIndex := 4; end;
    4: begin Result := SpeedButton3; ImageIndex := 6; end;
    5: begin Result := SpeedButton2; ImageIndex := 8; end;
    6: begin Result := SpeedButton9; ImageIndex := 10; end;
    7: begin Result := SpeedButton10; ImageIndex := 12; end;
    8: begin Result := SpeedButton8; ImageIndex := 14; end;
    9: begin Result := SpeedButton7; ImageIndex := 16; end;
    10: begin Result := SpeedButton1; ImageIndex := 18; end;
    11: begin Result := SpeedButton13; ImageIndex := 28; end;
    12: begin Result := SpeedButton14; ImageIndex := 30; end;
    13: begin Result := SpeedButton12; ImageIndex := 32; end;
    14: begin Result := SpeedButton17; ImageIndex := 34; end;
    15: begin Result := SpeedButton16; ImageIndex := 36; end;
    16: begin Result := SpeedButton15; ImageIndex := 38; end;
    17: begin Result := SpeedButton11; ImageIndex := 40; end;
  end;
end;

procedure TMainForm.SpeedButton11Click(Sender: TObject);
var
  P: TPoint;
begin
  P := SpeedButton11.ClientToScreen(Point(0, SpeedButton11.Height));
  if SpeedButton11.Enabled then PopUpMenu2.Popup(P.X, P.Y);
end;

procedure TMainForm.CancelOnlineOperation1Click(Sender: TObject);
begin
  if not AreWeOnline then Exit;
  OnlineThread.ShowError(MainForm.ListBox1.Items[82]);
end;

procedure TMainForm.Panel2Paint(Sender: TObject);
var
  I, E, H, W: Integer;
begin
  if bDrawBK then begin
    H := Image4.Picture.Bitmap.Height;
    W := Image4.Picture.Bitmap.Width;
    for I := 0 to (Panel2.Width div W)+1 do
      for E := 0 to (Panel2.Height div H)+1 do
        Panel2.Canvas.Draw(I*W, E*H, Image4.Picture.Bitmap);
  end;
end;

procedure TMainForm.SetToolbarButtonOrder;
var
  SL: TStringList;
  I, ImageIndex, Pos, E: Integer;
  B: TSpeedButtonEx;
  V: TBevel;
begin
  for I := 1 to iToolBarButtonCount do begin
    B := TSpeedButtonEx(FindComponent('SpeedButton'+IntToStr(I)));
    if bSmallToolbarButtons then begin
      B.Caption := '';
      B.Width := 32;
      B.Height := 32;
    end else begin
      B.Caption := B.Comment;
      B.Width := DefaultTlbButtonWidth;
      B.Height := DefaultTlbButtonHeight;
    end;
    if bFlatButtons = False then begin
      B.Width := B.Width+2;
      B.Height := B.Height+2;
    end;
  end;
  Panel2.Height := SpeedButton1.Height+6;
  //Position
  SL := TStringList.Create;
  CommataStringToStringList(sToolbarButtons, SL);
  Pos := 1;
  for I := 1 to iToolbarButtonCount do GetToolbarButttonByIndex(I, ImageIndex).Visible := False;
  for I := 0 to ToolbarSeperators.Count-1 do TBevel(ToolbarSeperators.Items[I]).Free;
  ToolbarSeperators.Clear;
  SpellCheck1.Visible := not (sSpellCheckerFile = '');
  for I := 0 to SL.Count-1 do begin
    E := StrToInt(SL.Strings[I]);
    B := GetToolbarButttonByIndex(E, ImageIndex);
    if B <> nil then begin
      if (E = 7) and (sSpellCheckerFile = '') then begin
        // Spell Checker
      end else begin
        B.Left := Pos;
        Inc(Pos, B.Width-1);
        B.BringToFront;
        B.Visible := True;
      end;
    end else begin
      V := TBevel.Create(Self);
      V.Shape := bsLeftLine;
      V.Width := 2;
      V.Height := SpeedButton1.Height;
      V.Top := SpeedButton1.Top;
      V.Left := Pos+2;
      Inc(Pos, 6);
      ToolbarSeperators.Add(V);
      V.Parent := Panel2;
      V.Visible := True;
      V.BringToFront;
    end;
  end;
  SL.Free;
  //Flat
  Set3DButtons(bFlatButtons, Self);
  for I := 0 to ToolbarSeperators.Count-1 do TBevel(ToolbarSeperators.Items[I]).Visible := bFlatButtons;
  ASpeedButton1.Flat := False;
  if bFlatButtons = False then Panel2.Height := SpeedButton1.Height+7;
  //Background
  if FileExists(sToolbarBKBitmap) and bFlatButtons and (iColorDepth > 8) then begin
    MainForm.Image4.Picture.LoadFromFile(sToolbarBKBitmap);
    bDrawBK := True;
  end else bDrawBK := False;
  MainForm.Panel2.Invalidate;
end;

procedure TMainForm.Configure1Click(Sender: TObject);
begin
  Modal1.Enabled := False;
  EnviroForm := TEnviroForm.Create(Self);
  EnviroForm.PageControl1.ActivePage := EnviroForm.TabSheet7;
  EnviroForm.ShowModal;
  EnviroForm.Free;
  Modal1.Enabled := True;
end;

procedure TMainForm.FlatButtons1Click(Sender: TObject);
begin
  bFlatButtons := not bFlatButtons;
  SetToolbarButtonOrder;
end;

procedure TMainForm.SmallButtons1Click(Sender: TObject);
begin
  bSmallToolbarButtons := not bSmallToolbarButtons;
  SetToolbarButtonOrder;
end;

procedure TMainForm.PopupMenu7Popup(Sender: TObject);
begin
  FlatButtons1.Checked := bFlatButtons;
  SmallButtons1.Checked := bSmallToolbarButtons;
end;

procedure TMainForm.TreeView1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Application.HandleMessage;
end;

end.
