{*****************************************************************************
 *
 *  Phoenix.dpr - Phoenix Mail (19-July-1998)
 *
 *  Copyright (c) 1998-99 Michael Haller
 *
 *  Author:     Michael Haller
 *  E-mail:     michael@discountdrive.com
 *  Homepage:   http://www.discountdrive.com/sunrise
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation;
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *----------------------------------------------------------------------------
 *
 *  Revision history:
 *
 *     DATE     REV                 DESCRIPTION
 *  ----------- --- ----------------------------------------------------------
 *
 *****************************************************************************}

program Phoenix;

uses
  Forms,
  Controls,
  SysUtils,
  Main in 'Main.pas' {MainForm},
  BASE64Sup in 'BASE64Sup.pas',
  MailParser in 'MailParser.pas',
  PXStuff in 'PXStuff.pas',
  FMMailOptions in 'FMMailOptions.pas' {MailOptionsForm},
  ParserSup in 'ParserSup.pas',
  DateSup in 'DateSup.pas',
  FMAccount in 'FMAccount.pas' {AccountForm},
  FMFolder in 'FMFolder.pas' {FolderForm},
  FMOnline in 'FMOnline.pas' {OnlineForm},
  FMEnviro in 'FMEnviro.pas' {EnviroForm},
  FMInfo in 'FMInfo.pas' {InfoForm},
  FMSplash in 'FMSplash.pas' {SplashForm},
  FMTips in 'FMTips.pas' {TipsForm},
  FMSelectMail in 'FMSelectMail.pas' {SelectMailForm},
  FMAddress in 'FMAddress.pas' {AddressForm},
  FMEditAdr in 'FMEditAdr.pas' {EditAdrForm},
  FMDirectory in 'FMDirectory.pas' {DirectoryForm},
  FMSignature in 'FMSignature.pas' {SignatureForm},
  FMSelBook in 'FMSelBook.pas' {SelBookForm},
  FMSearch in 'FMSearch.pas' {SearchForm},
  LangSup in 'LangSup.pas',
  FMLanguage in 'FMLanguage.pas' {LanguageForm},
  FMStdMail in 'FMStdMail.pas' {StdMailForm},
  FMSpellCheck in 'FMSpellCheck.pas' {SpellCheckForm},
  TDOnline in 'TDOnline.pas';

{$R *.RES}

begin
  Application.Initialize;
  if CheckForPrevInstance = False then Exit;
  if CheckCDROMStart = False then begin
    ClearUpCheckForPrevInstance;
    Exit;
  end;
  CheckColorDepth;
  SplashForm := TSplashForm.Create(Application);
  SplashForm.Show;
  Application.ProcessMessages;
  InitializePX;
  CheckVersion;
  CheckForStandardEMailProgram;
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TMailOptionsForm, MailOptionsForm);
  Application.CreateForm(TAddressForm, AddressForm);
  Application.ProcessMessages;
  SplashForm.Free;
  if (ParamCount >= 1) and (LowerCase(ParamStr(1)) = '-min') then begin
    Application.ShowMainForm := False;
    MainForm.AppMinimize(Application);
  end else begin
    MainForm.Show;
    if bShowTips then begin
      TipsForm := TTipsForm.Create(Application);
      TipsForm.ShowModal;
      TipsForm.Free;
    end;
  end;
  if MainForm.GetActualAccount = nil then MainForm.New1Click(Application);
  if sWriteNewMessage1 <> '' then begin
    MainForm.NewMessage(True, True, sWriteNewMessage2, sWriteNewMessage1, '', nil);
    sWriteNewMessage1 := '';
    sWriteNewMessage2 := '';
  end;
  if bGoOnlineAtStart then MainForm.GoOnline1Click(Application);
  Application.Run;
  ClearUpPX;
end.
